addHook("ThinkFrame", do
	for player in players.iterate
		if player.mo and player.mo.skin == "knucklesexe"
			if not (player.mo.dig1)
				player.mo.dig1 = 0
			end
			if player.mo.dig1 > 0
				player.mo.dig1 = $1 - 1
			end
			if not (player.mo.dig2)
				player.mo.dig2 = 0
			end
			if player.mo.dig2 > 0
				player.mo.dig2 = $1 - 1
			end
			if player.mo.dig1 > 1
			and player.playerstate == PST_LIVE
			and not (player.mo.sprite == SPR2_CLNG)
			and not (player.mo.state == S_PLAY_GLIDE or player.mo.state == S_PLAY_CLIMB)
				if not (P_IsObjectOnGround(player.mo))
				and not (player.mo.state == S_PLAY_GLIDE or player.mo.state == S_PLAY_CLIMB)
					player.mo.momx = FixedMul($, FRACUNIT*97/100)
					player.mo.momy = FixedMul($, FRACUNIT*97/100)
					player.mo.dig1 = 3
					player.mo.state = S_PLAY_ROLL
					P_SetObjectMomZ(player.mo, -45*FRACUNIT)
					local dig_ghost = P_SpawnGhostMobj(player.mo)
					dig_ghost.color = SKINCOLOR_RED
					dig_ghost.colorized = true
					dig_ghost.fuse = 4
					dig_ghost.frame = ($1 & ~FF_TRANSMASK)|FF_TRANS40
					dig_ghost.eflags = player.mo.eflags & MFE_VERTICALFLIP
				end
				if (P_IsObjectOnGround(player.mo))
					player.mo.dig2 = 1*TICRATE
				end
			end
			if player.mo.dig2 > 1
			and player.playerstate == PST_LIVE
			and not (player.mo.sprite == SPR2_CLNG)
			and not (player.mo.state == S_PLAY_GLIDE or player.mo.state == S_PLAY_CLIMB)
				player.mo.momx = FixedMul($, FRACUNIT*97/100)
				player.mo.momy = FixedMul($, FRACUNIT*97/100)
				if (P_IsObjectOnGround(player.mo))
					player.mo.flags = $|MF_NOCLIPTHING
					player.mo.flags2 = $1|MF2_DONTDRAW
					player.pflags = $1|PF_INVIS
					player.pflags = $1 & ~PF_SPINNING
					player.charability2 = CA2_NONE
					player.mo.dig1 = 0
					player.jumpfactor = 0
					local dig_particle = P_SpawnMobj(player.mo.x+P_RandomRange(-10,10)*FRACUNIT,player.mo.y+P_RandomRange(-10,10)*FRACUNIT,player.mo.z+player.mo.height-15*FRACUNIT+P_RandomRange(-10,10)*FRACUNIT, MT_SPINDUST)
					dig_particle.fuse = 7
					dig_particle.scale = player.mo.scale/2
					player.shieldscale = 0
					if (leveltime % 10) == 1
						S_StartSound(player.mo,sfx_s3k67)
					end
				end
				if not (P_IsObjectOnGround(player.mo))
					player.mo.dig1 = 0
					player.mo.dig2 = 0
					player.jumpfactor = skins[player.mo.skin].jumpfactor
					player.shieldscale = skins[player.mo.skin].shieldscale
					player.pflags = $1 & ~PF_INVIS
					player.mo.flags = $ & ~MF_NOCLIPTHING
					player.weapondelay = 3*TICRATE
					player.mo.state = S_PLAY_FALL
					player.charability2 = CA2_SPINDASH
					S_StartSound(player.mo, sfx_lose)
				end
			end
			if player.mo.dig2 == 1
			and player.playerstate == PST_LIVE
				player.jumpfactor = skins[player.mo.skin].jumpfactor
				player.shieldscale = skins[player.mo.skin].shieldscale
				player.mo.dig1 = 1
				player.pflags = $1 & ~PF_INVIS
				player.charability2 = CA2_SPINDASH
				player.mo.flags = $ & ~MF_NOCLIPTHING
				player.pflags = $1|PF_JUMPED
				player.weapondelay = 3*TICRATE
			end
			if (player.mo.eflags & MFE_JUSTHITFLOOR)
			and not (player.mo.eflags & MFE_UNDERWATER)
			and (player.mo.eflags & MFE_ONGROUND)
			and not (player.mo.eflags & MFE_SPRUNG)
			and not (player.mo.flags & FF_EXISTS) 
			and not (player.mo.flags & FF_STRONGBUST) 
			and not (player.mo.flags & FF_BUSTUP)
			and (player.mo.dig1 > 1 or player.mo.dig2 > 1)
			and not (player.mo.sprite == SPR2_CLNG)
			and not (player.mo.state == S_PLAY_GLIDE or player.mo.state == S_PLAY_CLIMB)
				S_StartSound(player.mo,sfx_s3kccs)
				if (player.mo.eflags & MFE_UNDERWATER)
					P_SpawnMobj(player.mo.x - 25*FRACUNIT, player.mo.y, player.mo.z, MT_MEDIUMBUBBLE)
					P_SpawnMobj(player.mo.x + 25*FRACUNIT, player.mo.y, player.mo.z, MT_MEDIUMBUBBLE)
					P_SpawnMobj(player.mo.x, player.mo.y - 25*FRACUNIT, player.mo.z, MT_MEDIUMBUBBLE)
					P_SpawnMobj(player.mo.x, player.mo.y + 25*FRACUNIT, player.mo.z, MT_MEDIUMBUBBLE)
					P_SpawnMobj(player.mo.x - 20*FRACUNIT, player.mo.y - 20*FRACUNIT, player.mo.z, MT_MEDIUMBUBBLE)
					P_SpawnMobj(player.mo.x + 20*FRACUNIT, player.mo.y - 20*FRACUNIT, player.mo.z, MT_MEDIUMBUBBLE)
					P_SpawnMobj(player.mo.x - 20*FRACUNIT, player.mo.y + 20*FRACUNIT, player.mo.z, MT_MEDIUMBUBBLE)
					P_SpawnMobj(player.mo.x + 20*FRACUNIT, player.mo.y + 20*FRACUNIT, player.mo.z, MT_MEDIUMBUBBLE)
				else
					P_SpawnMobj(player.mo.x - 25*FRACUNIT, player.mo.y, player.mo.z, MT_SPINDUST)
					P_SpawnMobj(player.mo.x + 25*FRACUNIT, player.mo.y, player.mo.z, MT_SPINDUST)
					P_SpawnMobj(player.mo.x, player.mo.y - 25*FRACUNIT, player.mo.z, MT_SPINDUST)
					P_SpawnMobj(player.mo.x, player.mo.y + 25*FRACUNIT, player.mo.z, MT_SPINDUST)
					P_SpawnMobj(player.mo.x - 20*FRACUNIT, player.mo.y - 20*FRACUNIT, player.mo.z, MT_SPINDUST)
					P_SpawnMobj(player.mo.x + 20*FRACUNIT, player.mo.y - 20*FRACUNIT, player.mo.z, MT_SPINDUST)
					P_SpawnMobj(player.mo.x - 20*FRACUNIT, player.mo.y + 20*FRACUNIT, player.mo.z, MT_SPINDUST)
					P_SpawnMobj(player.mo.x + 20*FRACUNIT, player.mo.y + 20*FRACUNIT, player.mo.z, MT_SPINDUST)
				end
			end
			if player.mo.dig2 == 1
			and player.playerstate == PST_LIVE
				player.mo.state = S_PLAY_SPRING
				player.pflags = $1 & ~PF_INVIS
				player.mo.flags = $ & ~MF_NOCLIPTHING
				S_StartSound(player.mo, sfx_s3ka0)
				if (P_IsObjectOnGround(player.mo))
					if (player.mo.eflags & MFE_UNDERWATER)
						P_SpawnMobj(player.mo.x - 25*FRACUNIT, player.mo.y, player.mo.z, MT_MEDIUMBUBBLE)
						P_SpawnMobj(player.mo.x + 25*FRACUNIT, player.mo.y, player.mo.z, MT_MEDIUMBUBBLE)
						P_SpawnMobj(player.mo.x, player.mo.y - 25*FRACUNIT, player.mo.z, MT_MEDIUMBUBBLE)
						P_SpawnMobj(player.mo.x, player.mo.y + 25*FRACUNIT, player.mo.z, MT_MEDIUMBUBBLE)
						P_SpawnMobj(player.mo.x - 20*FRACUNIT, player.mo.y - 20*FRACUNIT, player.mo.z, MT_MEDIUMBUBBLE)
						P_SpawnMobj(player.mo.x + 20*FRACUNIT, player.mo.y - 20*FRACUNIT, player.mo.z, MT_MEDIUMBUBBLE)
						P_SpawnMobj(player.mo.x - 20*FRACUNIT, player.mo.y + 20*FRACUNIT, player.mo.z, MT_MEDIUMBUBBLE)
						P_SpawnMobj(player.mo.x + 20*FRACUNIT, player.mo.y + 20*FRACUNIT, player.mo.z, MT_MEDIUMBUBBLE)
						P_SetObjectMomZ(player.mo, 5*FRACUNIT)
					else
						P_SpawnMobj(player.mo.x - 25*FRACUNIT, player.mo.y, player.mo.z, MT_SPINDUST)
						P_SpawnMobj(player.mo.x + 25*FRACUNIT, player.mo.y, player.mo.z, MT_SPINDUST)
						P_SpawnMobj(player.mo.x, player.mo.y - 25*FRACUNIT, player.mo.z, MT_SPINDUST)
						P_SpawnMobj(player.mo.x, player.mo.y + 25*FRACUNIT, player.mo.z, MT_SPINDUST)
						P_SpawnMobj(player.mo.x - 20*FRACUNIT, player.mo.y - 20*FRACUNIT, player.mo.z, MT_SPINDUST)
						P_SpawnMobj(player.mo.x + 20*FRACUNIT, player.mo.y - 20*FRACUNIT, player.mo.z, MT_SPINDUST)
						P_SpawnMobj(player.mo.x - 20*FRACUNIT, player.mo.y + 20*FRACUNIT, player.mo.z, MT_SPINDUST)
						P_SpawnMobj(player.mo.x + 20*FRACUNIT, player.mo.y + 20*FRACUNIT, player.mo.z, MT_SPINDUST)
						P_SetObjectMomZ(player.mo, 15*FRACUNIT)
					end
				end
			end
			if not (player.mo.custom1down)
				player.mo.custom1down = 0
			end
			if not (player.mo.custom2down)
				player.mo.custom2down = 0
			end
			if (player.cmd.buttons & BT_CUSTOM1)
			and not player.exiting
			and not player.powers[pw_carry]
			and not (player.pflags & PF_STASIS)
			and not (player.mo.state == S_PLAY_SUPER_TRANS1)
			and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
			and player.mo.custom1down == 0
			and player.playerstate == PST_LIVE
			and not player.weapondelay
			and not (player.mo.sprite == SPR2_CLNG)
			and not (player.mo.state == S_PLAY_GLIDE or player.mo.state == S_PLAY_CLIMB)
				player.mo.custom1down = 1
				player.weapondelay = 3*TICRATE
				player.mo.state = S_PLAY_EDGE
				S_StartSound(player.mo, sfx_fire)
				P_SpawnParaloop(player.mo.x, player.mo.y, player.mo.z, player.mo.scale*64,12, MT_DUST,ANGLE_90,nil,true)
				local an = player.mo.angle
				local slope = player.aiming
				local exebomb = P_SPMAngle(player.mo, MT_FBOMB, player.drawangle, 0)
				exebomb.scale = player.mo.scale
				exebomb.target = player.mo
				P_SetObjectMomZ(exebomb, 18*FRACUNIT)
				local speed = 70*FRACUNIT
				if player.mo.eflags & MFE_VERTICALFLIP then
					exebomb.flags2 = $1|MF2_OBJECTFLIP
					exebomb.z = $1 - exebomb.height - player.mo.height/3
				end
				exebomb.angle = an
				exebomb.momx = FixedMul(speed, cos(an))
				exebomb.momy = FixedMul(speed, sin(an))
				exebomb.momx = FixedMul(exebomb.momx, cos(slope))
				exebomb.momy = FixedMul(exebomb.momy, cos(slope))
				exebomb.momz = FixedMul(speed, sin(slope))
			end
			if (player.cmd.buttons & BT_CUSTOM2)
			and not player.exiting
			and not player.powers[pw_carry]
			and not (player.pflags & PF_STASIS)
			and not (player.mo.state == S_PLAY_SUPER_TRANS1)
			and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
			and player.mo.custom2down == 0
			and not (player.mo.state == S_PLAY_GLIDE or player.mo.state == S_PLAY_CLIMB)
			and not (player.mo.sprite == SPR2_CLNG)
			and not player.weapondelay
			and not (player.mo.dig2 > 1 or player.mo.dig1 > 1)
			and player.playerstate == PST_LIVE
				player.mo.custom2down = 1
				player.mo.dig1 = 38
				if (P_IsObjectOnGround(player.mo))
					S_StartSound(player.mo,sfx_s3kccs)
				else
					S_StartSound(player.mo, sfx_zoom)
				end
			end
			if not (player.cmd.buttons & BT_CUSTOM1)
				player.mo.custom1down = 0
			end
			if not (player.cmd.buttons & BT_CUSTOM2)
				player.mo.custom2down = 0
			end
			if not player.powers[pw_super] then
				if (player.speed > 36*FRACUNIT)
					if not player.powers[pw_sneakers]
						player.normalspeed = 47*FRACUNIT
					end
					if (player.mo and player.mo.skin == "knucklesexe")
						if not (player.mo.state == S_PLAY_DASH)
						and not (player.pflags & PF_SPINNING)
						and P_IsObjectOnGround(player.mo)
						and (player.mo.state == S_PLAY_RUN)
							player.mo.state = S_PLAY_DASH
						end
					end
				elseif (player.speed >= 0)
				and (player.speed < 42*FRACUNIT)
					if (player.mo and player.mo.skin == "knucklesexe")
					and not player.powers[pw_super] then
						player.normalspeed = 38*FRACUNIT
					end	
					if (player.mo.state == S_PLAY_DASH)
					and P_IsObjectOnGround(player.mo)
						player.mo.state = S_PLAY_RUN
					end
				end
			end
		end
	end
end)

addHook("MobjMoveCollide", function(pmo, spike)
	if (pmo.valid) 
	and (pmo.skin == "knucklesexe") 
	and ((pmo.state == S_PLAY_DASH) or (pmo.state == S_PLAY_RUN) or (pmo.state == S_PLAY_ROLL))
	and (spike.valid)
	and (spike.type == MT_SPIKE)
	and (pmo.z >= spike.z) and (pmo.z < spike.z+spike.height)
		P_KillMobj(spike, pmo, pmo)
	end
end, MT_PLAYER)

addHook("MobjThinker", function(knucklesexe)
	if (knucklesexe and knucklesexe.skin == "knucklesexe") //if you're knucklesexe..
	and knucklesexe.player.playerstate == PST_LIVE //you alive bruh?
	//and not (knucklesexe.player.powers[pw_super]) //super knucklesexe has float instead
		if knucklesexe.player.knucklesexebounceattack == nil //if the variable doesnt exist
			knucklesexe.player.knucklesexebounceattack = 0 //create variable
		end
		if knucklesexe.player.knucklesexebouncenumber == nil //if the variable doesnt exist
			knucklesexe.player.knucklesexebouncenumber = 0 //create variable
			knucklesexe.player.justchangedknucklesexebouncenumber = 0 //create variable
		end
		if P_IsObjectOnGround(knucklesexe) //are you on the ground?
		and knucklesexe.player.knucklesexebounceattack == 0 //the player isnt bouncing
			knucklesexe.player.knucklesexebouncenumber = 0 //set it to zero!
		end
		if knucklesexe.player.custom1down == nil //if the variable doesnt exist
		or not (knucklesexe.player.cmd.buttons & BT_SPIN) //not pressing the spin button?
			knucklesexe.player.custom1down = 0 //create variable
			knucklesexe.player.justchangedknucklesexebouncenumber = 0 //create variable
		end
		if P_IsObjectOnGround(knucklesexe) //Is the player on the ground?
		and (knucklesexe.player.cmd.buttons & BT_SPIN) //Is the player holding the spin button?
			knucklesexe.player.custom1down = 1 //Set it to one!
		end
		if knucklesexe.player.pflags & PF_JUMPED //if the player has jumped
		and not (knucklesexe.player.pflags & PF_THOKKED or knucklesexe.player.pflags & PF_GLIDING)
		and not knucklesexe.player.climbing //and the player hasnt used their mid-air ability
		and not (P_IsObjectOnGround(knucklesexe)) //and you arent on the ground.
		and knucklesexe.player.cmd.buttons & BT_SPIN //pressing custom2?
		and knucklesexe.player.knucklesexebounceattack == 0 //checking if the custom variable it set to 0
		and knucklesexe.player.custom1down == 0 //make sure you arent holding the spin button.
		and not (knucklesexe.player.exiting) //not...exiting the level?
		and knucklesexe.health //you're alive?
		and not (P_PlayerInPain(knucklesexe.player)) //not hurt are you?
			knucklesexe.player.knucklesexebounceattack = 1 //set it to one!
			P_SetObjectMomZ(knucklesexe, -35*FRACUNIT) //make the player "shoot" downward
			//P_SetObjectMomZ(knucklesexe, FixedMul(-35*FRACUNIT, knucklesexe.scale)) //make the player shoot downwards 
			knucklesexe.player.pflags = $1 & ~PF_GLIDING
			knucklesexe.player.pflags = $1|PF_THOKKED
		end
			
		if (knucklesexe.eflags & MFE_JUSTHITFLOOR) //you're on the ground.
		and not (knucklesexe.player.pflags & PF_SPINNING) //you arent spinning....somehow
		and not (knucklesexe.player.pflags & PF_STARTDASH) //you arent doing a spindash
		and not (knucklesexe.tracer and knucklesexe.tracer.type == MT_TUBEWAYPOINT) //not in a...zoomtube?
		and knucklesexe.player.knucklesexebounceattack == 1 //our custom variable is one right...?
		and knucklesexe.health //is the player alive..?
		and not (P_PlayerInPain(knucklesexe.player)) //not hurt are you?
			if knucklesexe.player.knucklesexebouncenumber == 0 //if he hasnt knucklesexebounced yet
			and knucklesexe.player.justchangedknucklesexebouncenumber == 0 //if he hasnt left the ground yet
				knucklesexe.player.justchangedknucklesexebouncenumber = 1 //now he has!
				knucklesexe.player.knucklesexebouncenumber = 1 //Set this to one!
				knucklesexe.player.pflags = $1|PF_JUMPED //forcing the player into a jumping state.
				P_SetObjectMomZ(knucklesexe, 13*FRACUNIT)
				if not (knucklesexe.player.panim == PA_ROLL) //checking if the players animation is it's spinning anim.
					knucklesexe.state = S_PLAY_ROLL //force the player into a spinning state.
				end
			end
			if knucklesexe.player.knucklesexebouncenumber == 1 //if it's currently on his first knucklesexebounce
			and knucklesexe.player.justchangedknucklesexebouncenumber == 0 //if he hasnt left the ground yet
			and not (P_PlayerInPain(knucklesexe.player)) //not hurt are you?
				knucklesexe.player.justchangedknucklesexebouncenumber = 1 //now he has!
				knucklesexe.player.knucklesexebouncenumber = 2 //set this to two!
				knucklesexe.player.pflags = $1|PF_JUMPED //forcing the player into a jumping state.
				P_SetObjectMomZ(knucklesexe, 13*FRACUNIT)
				if not (knucklesexe.player.panim == PA_ROLL) //checking if the players animation is it's spinning anim.
					knucklesexe.state = S_PLAY_ROLL //force the player into a spinning state.
				end
			end
			if knucklesexe.player.knucklesexebouncenumber == 2 //if it's currently on his second knucklesexebounce
			and knucklesexe.player.justchangedknucklesexebouncenumber == 0 //if he hasnt left the ground yet
			and not (P_PlayerInPain(knucklesexe.player)) //not hurt are you?
				knucklesexe.player.justchangedknucklesexebouncenumber = 1 //now he has!
				knucklesexe.player.knucklesexebouncenumber = 2 //set it back to zero
				knucklesexe.player.pflags = $1|PF_JUMPED //forcing the player into a jumping state.
				P_SetObjectMomZ(knucklesexe, 13*FRACUNIT)
				if not (knucklesexe.player.panim == PA_ROLL) //checking if the players animation is it's spinning anim.
					knucklesexe.player.state = S_PLAY_SPRING //force the player into a spinning state.
				end
			end
			knucklesexe.player.knucklesexebounceattack = 0 //set it back to zero.
			knucklesexe.player.custom1down = 1 //set it to one.
			knucklesexe.player.pflags = $1 & ~PF_JUMPED
			knucklesexe.player.state = S_PLAY_SPRING
			knucklesexe.player.pflags = $1 & ~PF_THOKKED //uncheck the thokked flag, allowing you to knucklesexebounce again.
			S_StartSound(knucklesexe, sfx_s3k44) //play a sound c:			
			
		end
		//some quick checks
		
		if knucklesexe.player.knucklesexebounceattack == 1 //checking our variable.
		and knucklesexe.health //and you're alive
		and not (P_PlayerInPain(knucklesexe.player)) //not hurt are you?
			P_SpawnGhostMobj(knucklesexe) //spawn the players thok object
			if not (knucklesexe.player.panim == PA_ROLL) //checking if the players animation is it's spinning anim.
				knucklesexe.state = S_PLAY_ROLL //force the player into a spinning state.
			end
			if (knucklesexe.momz > (9000*P_MobjFlip(knucklesexe))) // the player is going up...?  
				P_SetObjectMomZ(knucklesexe, FixedMul(-35*FRACUNIT, knucklesexe.scale)) //not anymore >.>
			end
		else 
			knucklesexe.player.knucklesexebounceattack = 0 //set it to 0
		end
		if knucklesexe.player.knucklesexebounceattack == 1 //checking if hes bouncing
			knucklesexe.player.pflags = $1 & ~PF_SPINNING // you're no longer "spinning" if you were before
		end
		if not (knucklesexe.player.pflags & PF_JUMPED) // if you are not actuallly jumping
			knucklesexe.player.knucklesexebounceattack = 0 //set this back to zero to be safe
		end
		
		if knucklesexe.eflags & MFE_GOOWATER //is the player in THZ goop?
		or knucklesexe.player.powers[pw_carry] //is the player being carried?
		//or knucklesexe.player.pflags & PF_ROPEHANG //is the player on a ACZ ropehang?
			knucklesexe.player.knucklesexebounceattack = 0 //set to zero!
		end
		if not (knucklesexe.player.pflags & PF_JUMPED) //if the player hasnt jumped
			knucklesexe.player.knucklesexebounceattack = 0 //set this to zero
		end
	end
end, MT_PLAYER)