//Color EXE
freeslot("SKINCOLOR_EXEFORGE", "SKINCOLOR_OLD_EXEFORGE")

//BonusType Sound
freeslot("sfx_exevce")

//R.e.a.d.y F.o.r R.o.u.n.d 2? - This is Sound from victory boss
freeslot("sfx_exerr2")

skincolors[SKINCOLOR_EXEFORGE] = {
    name = "ExeForge",
    ramp = {146,150,153,155,156,157,158,159,253,253,253,253,254,254,30,31},
    invcolor = SKINCOLOR_COBALT,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = true
}

skincolors[SKINCOLOR_OLD_EXEFORGE] = {
    name = "(OLD)ExeForge",
    ramp = {149,150,150,155,156,156,157,158,158,159,253,253,254,254,30,3},
    invcolor = SKINCOLOR_COBALT,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = true
}
//Hyper Form Color
freeslot("SKINCOLOR_SUPER_HYPER_1","SKINCOLOR_SUPER_HYPER_2","SKINCOLOR_SUPER_HYPER_3","SKINCOLOR_SUPER_HYPER_4","SKINCOLOR_SUPER_HYPER_5", "SKINCOLOR_SUPER_HYPER_6")

skincolors[SKINCOLOR_SUPER_HYPER_1] = {
    name = "Super Hyper 1",
    ramp = {210,210,32,32,33,33,34,34,34,37,37,37,38,39,40,40
},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPER_HYPER_2] = {
    name = "Super Hyper 2",
    ramp = {0,1,252,252,200,200,200,209,201,201,201,202,202,202,202,203
},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPER_HYPER_3] = {
    name = "Super Hyper 3",
    ramp = {209,209,210,210,32,32,32,33,33,33,34,34,34,34,35,35
},
    invcolor = SKINCOLOR_KETCHUP,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPER_HYPER_4] = {
    name = "Super Hyper 4",
    ramp = {0,1,1,80,80,88,88,88,88,89,89,89,89,96,96,96
},
    invcolor = SKINCOLOR_ORANGE,
	
	
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPER_HYPER_5] = {
    name = "Super Hyper 5",
    ramp = {176,176,177,178,179,179,180,180,182,183,183,184,184,184,184,185

},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}
skincolors[SKINCOLOR_SUPER_HYPER_6] = {
    name = "Super Hyper 6",
    ramp = {0,1,1,208,208,48,48,216,49,49,49,50,50,50,51,51
},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 9,
    chatcolor = V_BLUEMAP,
    accessible = false
}

//RedGold Super Form
freeslot("SKINCOLOR_SUPERREDGOLD", "SKINCOLOR_SUPERREDGOLD1", "SKINCOLOR_SUPERREDGOLD2", "SKINCOLOR_SUPERREDGOLD3", "SKINCOLOR_SUPERREDGOLD4", "SKINCOLOR_SUPERREDGOLD5")

skincolors[SKINCOLOR_SUPERREDGOLD1] = {
	name = "Super RedGold 1",
	ramp = {0,0,0,0,0,0,0,81,81,64,64,65,65,66,67,67},
	accessible = false
}

skincolors[SKINCOLOR_SUPERREDGOLD2] = {
	name = "Super RedGold 2",
	ramp = {0,0,0,0,0,81,81,83,83,50,52,53,53,55,55,58},
	accessible = false
}

skincolors[SKINCOLOR_SUPERREDGOLD3] = {
	name = "Super RedGold 3",
	ramp = {0,48,48,49,49,51,52,53,53,54,55,56,58,58,39,39},
	accessible = false
}

skincolors[SKINCOLOR_SUPERREDGOLD4] = {
	name = "Super RedGold 4",
	ramp = {48,48,218,218,32,33,33,34,34,35,35,36,36,38,39,39},
	accessible = false
}

skincolors[SKINCOLOR_SUPERREDGOLD5] = {
	name = "Super RedGold 5",
	ramp = {209,210,32,33,34,34,35,36,36,38,39,40,41,43,44,44},
	accessible = false
}

addHook("ThinkFrame", do
    skincolors[SKINCOLOR_SUPERREDGOLD].ramp = skincolors[SKINCOLOR_SUPERREDGOLD + abs( ( (leveltime >> 1) % 9) - 4)].ramp
end)


//Skul Shot
freeslot("MT_SKULSHOT")

addHook("MobjThinker", function(mo)
	if mo
	and mo.valid
	and mo.type == MT_SKULSHOT
	and mo.state == mobjinfo[mo.type].spawnstate
		local bluedetalskul = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		bluedetalskul.state = S_BLUEFIRE1
		bluedetalskul.frame = FF_ANIMATE
	end
end, MT_SKULSHOT)

//AddThok
freeslot("MT_EXEPARTICLE", "MT_EXEPARTICLE2", "S_EXEPARTICLE", "SPR_SPWR")

mobjinfo[MT_EXEPARTICLE] = {
	spawnstate = S_EXEPARTICLE,
	radius = 128*FRACUNIT,
	height = 64*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT,
	dispoffset = 3
}

mobjinfo[MT_EXEPARTICLE2] = {
	spawnstate = S_EXEPARTICLE,
	radius = 128*FRACUNIT,
	height = 64*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT,
	dispoffset = 3
}

states[S_EXEPARTICLE] = {
	sprite = SPR_SPWR,
	frame = A|FF_FULLBRIGHT|TR_TRANS10,
	var1 = 5,
	var2 = 1,
	tics = 6
}

freeslot("SPR_CHOS", "MT_CHAOSEXEPARTICLE", "S_CHAOSEXEPARTICLE1", "S_CHAOSEXEPARTICLE2", "S_CHAOSEXEPARTICLE3", "S_CHAOSEXEPARTICLE4")

mobjinfo[MT_CHAOSEXEPARTICLE] = {


	spawnstate = S_CHAOSEXEPARTICLE1,
	radius = 128*FRACUNIT,
	height = 64*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT,
	dispoffset = 3
}

states[S_CHAOSEXEPARTICLE1] = {
        sprite = SPR_CHOS,
        frame = A|FF_FULLBRIGHT,
        tics = 1,
        var1 = 4,
        var2 = 2,
        nextstate = S_NULL
}

states[S_CHAOSEXEPARTICLE2] = {
        sprite = SPR_CHOS,
        frame = B|FF_FULLBRIGHT,
        tics = 1,
        var1 = 4,
        var2 = 2,
        nextstate = S_NULL
}


states[S_CHAOSEXEPARTICLE3] = {
        sprite = SPR_CHOS,
        frame = C|FF_FULLBRIGHT,
        tics = 1,
        var1 = 4,
        var2 = 2,
        nextstate = S_NULL
}


states[S_CHAOSEXEPARTICLE4] = {
        sprite = SPR_CHOS,
        frame = D|FF_FULLBRIGHT,
        tics = 1,
        var1 = 4,
        var2 = 2,
        nextstate = S_NULL
}

//Exe Particle - Part 1
addHook("MobjThinker", function(mo)
	if mo
	and mo.valid
	and mo.type == MT_EXEPARTICLE
	and mo.state == mobjinfo[mo.type].spawnstate
		local bluedetalskul = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		bluedetalskul.state = S_BLUEFIRE1
		bluedetalskul.frame = FF_ANIMATE
	end
end, MT_EXEPARTICLE)

//EXE particle - part 2
addHook("MobjThinker", function(mo)
	if mo
	and mo.target
	and mo.type == MT_EXEPARTICLE2
	and mo.state == mobjinfo[mo.type].spawnstate
	and mo.target.player.powers[pw_shield] & ~SH_FIREFLOWER == SH_NONE
	and not mo.target.player.powers[pw_super]
		if mo.target
		and mo.target.valid
			A_Custom3DRotate(mo, 32*FRACUNIT+64, 64*FRACUNIT+64)
		end
		local bluedetalskul2 = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		bluedetalskul2.state = S_BLUEFIRE1
		bluedetalskul2.frame = FF_ANIMATE
	end
	if mo
	and mo.target
	and mo.type == MT_EXEPARTICLE2
	and mo.state == mobjinfo[mo.type].spawnstate
	and mo.target.player.powers[pw_super]
	and mo.target.player.powers[pw_shield] & ~SH_FIREFLOWER == SH_NONE
		if mo.target
		and mo.target.valid
			A_Custom3DRotate(mo, 32*FRACUNIT+64, 64*FRACUNIT+64)
		end
		local superbluedetalskul2 = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		superbluedetalskul2.state = S_BLUEFIRE1
		superbluedetalskul2.frame = FF_ANIMATE
	end
	if mo
	and mo.target
	and mo.type == MT_EXEPARTICLE2
	and mo.state == mobjinfo[mo.type].spawnstate
	and mo.target.player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ELEMENTAL
	and not mo.target.player.powers[pw_super]
		if mo.target
		and mo.target.valid
			A_Custom3DRotate(mo, 32*FRACUNIT+64, 64*FRACUNIT+64)
		end
		local elementalparticle = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		elementalparticle.state = S_BLUEFIRE1
		elementalparticle.frame = FF_ANIMATE
		elementalparticle.color = SKINCOLOR_MINT
		elementalparticle.colorized = true
	end
	if mo
	and mo.target
	and mo.type == MT_EXEPARTICLE2
	and mo.state == mobjinfo[mo.type].spawnstate
	and mo.target.player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FLAMEAURA
	and not mo.target.player.powers[pw_super]
		if mo.target
		and mo.target.valid
			A_Custom3DRotate(mo, 32*FRACUNIT+64, 64*FRACUNIT+64)
		end
		local flameaurashieldparticle = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		flameaurashieldparticle.state = S_BLUEFIRE1
		flameaurashieldparticle.frame = FF_ANIMATE
		flameaurashieldparticle.color = SKINCOLOR_KETCHUP
		flameaurashieldparticle.colorized = true
	end
	if mo
	and mo.target
	and mo.type == MT_EXEPARTICLE2
	and mo.state == mobjinfo[mo.type].spawnstate
	and mo.target.player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ARMAGEDDON
	and not mo.target.player.powers[pw_super]
		if mo.target
		and mo.target.valid
			A_Custom3DRotate(mo, 32*FRACUNIT+64, 64*FRACUNIT+64)
		end
		local armageddonparticle = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		armageddonparticle.state = S_BLUEFIRE1
		armageddonparticle.frame = FF_ANIMATE
		armageddonparticle.color = SKINCOLOR_SALMON
		armageddonparticle.colorized = true
	end
	if mo
	and mo.target
	and mo.type == MT_EXEPARTICLE2
	and mo.state == mobjinfo[mo.type].spawnstate
	and mo.target.player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ATTRACT
	and not mo.target.player.powers[pw_super]
		if mo.target
		and mo.target.valid
			A_Custom3DRotate(mo, 32*FRACUNIT+64, 64*FRACUNIT+64)
		end
		local attractparticle = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		attractparticle.state = S_BLUEFIRE1
		attractparticle.frame = FF_ANIMATE
		attractparticle.color = SKINCOLOR_YELLOW
		attractparticle.colorized = true
	end
	if mo
	and mo.target
	and mo.type == MT_EXEPARTICLE2
	and mo.state == mobjinfo[mo.type].spawnstate
	and mo.target.player.powers[pw_shield] & ~SH_FIREFLOWER == SH_THUNDERCOIN
	and not mo.target.player.powers[pw_super]
		if mo.target
		and mo.target.valid
			A_Custom3DRotate(mo, 32*FRACUNIT+64, 64*FRACUNIT+64)
		end
		local thunderparticle = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		thunderparticle.state = S_BLUEFIRE1
		thunderparticle.frame = FF_ANIMATE
		thunderparticle.color = SKINCOLOR_GOLD
		thunderparticle.colorized = true
	end
	if mo
	and mo.target
	and mo.type == MT_EXEPARTICLE2
	and mo.state == mobjinfo[mo.type].spawnstate
	and (mo.target.player.powers[pw_shield] == SH_FORCE|1)
	and not mo.target.player.powers[pw_super]
		if mo.target
		and mo.target.valid
			A_Custom3DRotate(mo, 32*FRACUNIT+64, 64*FRACUNIT+64)
		end
		local forceparticle1 = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		forceparticle1.state = S_BLUEFIRE1
		forceparticle1.frame = FF_ANIMATE
		forceparticle1.color = SKINCOLOR_PURPLE
		forceparticle1.colorized = true
	end
	if mo
	and mo.target
	and mo.type == MT_EXEPARTICLE2
	and mo.state == mobjinfo[mo.type].spawnstate
	and (mo.target.player.powers[pw_shield] == SH_FORCE)
	and not mo.target.player.powers[pw_super]
		if mo.target
		and mo.target.valid
			A_Custom3DRotate(mo, 32*FRACUNIT+64, 64*FRACUNIT+64)
		end
		local forceparticle2 = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		forceparticle2.state = S_BLUEFIRE1
		forceparticle2.frame = FF_ANIMATE
		forceparticle2.color = SKINCOLOR_PASTEL
		forceparticle2.colorized = true
	end
	if mo
	and mo.target
	and mo.type == MT_EXEPARTICLE2
	and mo.state == mobjinfo[mo.type].spawnstate
	and mo.target.player.powers[pw_shield] & ~SH_FIREFLOWER == SH_BUBBLEWRAP
	and not mo.target.player.powers[pw_super]
		if mo.target
		and mo.target.valid
			A_Custom3DRotate(mo, 32*FRACUNIT+64, 64*FRACUNIT+64)
		end
		local bubbleparticle = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		bubbleparticle.state = S_BLUEFIRE1
		bubbleparticle.frame = FF_ANIMATE
		bubbleparticle.color = SKINCOLOR_SAPPHIRE
		bubbleparticle.colorized = true
	end
	if mo
	and mo.target
	and mo.type == MT_EXEPARTICLE2
	and mo.state == mobjinfo[mo.type].spawnstate
	and mo.target.player.powers[pw_shield] & ~SH_FIREFLOWER == SH_WHIRLWIND
	and not mo.target.player.powers[pw_super]
		if mo.target
		and mo.target.valid
			A_Custom3DRotate(mo, 32*FRACUNIT+64, 64*FRACUNIT+64)
		end
		local whirlparticle = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		whirlparticle.state = S_BLUEFIRE1
		whirlparticle.frame = FF_ANIMATE
		whirlparticle.color = SKINCOLOR_WHITE
		whirlparticle.colorized = true
	end
	if mo
	and mo.target
	and mo.type == MT_EXEPARTICLE2
	and mo.state == mobjinfo[mo.type].spawnstate
	and mo.target.player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PITY
	and not mo.target.player.powers[pw_super]
		if mo.target
		and mo.target.valid
			A_Custom3DRotate(mo, 32*FRACUNIT+64, 64*FRACUNIT+64)
		end
		local pityparticle = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		pityparticle.state = S_BLUEFIRE1
		pityparticle.frame = FF_ANIMATE
		pityparticle.color = SKINCOLOR_GREEN
		pityparticle.colorized = true
	end
	if mo
	and mo.target
	and mo.type == MT_EXEPARTICLE2
	and mo.state == mobjinfo[mo.type].spawnstate
	and mo.target.player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PINK
	and not mo.target.player.powers[pw_super]
		if mo.target
		and mo.target.valid
			A_Custom3DRotate(mo, 32*FRACUNIT+64, 64*FRACUNIT+64)
		end
		local pinkparticle = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		pinkparticle.state = S_BLUEFIRE1
		pinkparticle.frame = FF_ANIMATE
		pinkparticle.color = SKINCOLOR_ROSY
		pinkparticle.colorized = true
	end
	if mo
	and mo.target
	and mo.type == MT_EXEPARTICLE2
	and mo.state == mobjinfo[mo.type].spawnstate
	and mo.target.player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ELEMENTAL
	and mo.target.player.powers[pw_super]
		if mo.target
		and mo.target.valid
			A_Custom3DRotate(mo, 32*FRACUNIT+64, 64*FRACUNIT+64)
		end
		local superelementalparticle = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		superelementalparticle.state = S_BLUEFIRE1
		superelementalparticle.frame = FF_ANIMATE
	end
	if mo
	and mo.target
	and mo.type == MT_EXEPARTICLE2
	and mo.state == mobjinfo[mo.type].spawnstate
	and mo.target.player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FLAMEAURA
	and mo.target.player.powers[pw_super]
		if mo.target
		and mo.target.valid
			A_Custom3DRotate(mo, 32*FRACUNIT+64, 64*FRACUNIT+64)
		end
		local superflameaurashieldparticle = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		superflameaurashieldparticle.state = S_BLUEFIRE1
		superflameaurashieldparticle.frame = FF_ANIMATE
	end
	if mo
	and mo.target
	and mo.type == MT_EXEPARTICLE2
	and mo.state == mobjinfo[mo.type].spawnstate
	and mo.target.player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ARMAGEDDON
	and mo.target.player.powers[pw_super]
		if mo.target
		and mo.target.valid
			A_Custom3DRotate(mo, 32*FRACUNIT+64, 64*FRACUNIT+64)
		end
		local superarmaggedonparticle = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		superarmaggedonparticle.state = S_BLUEFIRE1
		superarmaggedonparticle.frame = FF_ANIMATE
	end
	if mo
	and mo.target
	and mo.type == MT_EXEPARTICLE2
	and mo.state == mobjinfo[mo.type].spawnstate
	and mo.target.player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ATTRACT
	and mo.target.player.powers[pw_super]
		if mo.target
		and mo.target.valid
			A_Custom3DRotate(mo, 32*FRACUNIT+64, 64*FRACUNIT+64)
		end
		local superattractparticle = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		superattractparticle.state = S_BLUEFIRE1
		superattractparticle.frame = FF_ANIMATE
	end
	if mo
	and mo.target
	and mo.type == MT_EXEPARTICLE2
	and mo.state == mobjinfo[mo.type].spawnstate
	and mo.target.player.powers[pw_shield] & ~SH_FIREFLOWER == SH_THUNDERCOIN
	and mo.target.player.powers[pw_super]
		if mo.target
		and mo.target.valid
			A_Custom3DRotate(mo, 32*FRACUNIT+64, 64*FRACUNIT+64)
		end
		local superthunderparticle = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		superthunderparticle.state = S_BLUEFIRE1
		superthunderparticle.frame = FF_ANIMATE
	end
	if mo
	and mo.target
	and mo.type == MT_EXEPARTICLE2
	and mo.state == mobjinfo[mo.type].spawnstate
	and (mo.target.player.powers[pw_shield] == SH_FORCE)
	and mo.target.player.powers[pw_super]
		if mo.target
		and mo.target.valid
			A_Custom3DRotate(mo, 32*FRACUNIT+64, 64*FRACUNIT+64)
		end
		local superforceparticle1 = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		superforceparticle1.state = S_BLUEFIRE1
		superforceparticle1.frame = FF_ANIMATE
	end
	if mo
	and mo.target
	and mo.type == MT_EXEPARTICLE2
	and mo.state == mobjinfo[mo.type].spawnstate
	and (mo.target.player.powers[pw_shield] == SH_FORCE|1)
	and mo.target.player.powers[pw_super]
		if mo.target
		and mo.target.valid
			A_Custom3DRotate(mo, 32*FRACUNIT+64, 64*FRACUNIT+64)
		end
		local superforceparticle2 = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		superforceparticle2.state = S_BLUEFIRE1
		superforceparticle2.frame = FF_ANIMATE
	end
	if mo
	and mo.target
	and mo.type == MT_EXEPARTICLE2
	and mo.state == mobjinfo[mo.type].spawnstate
	and mo.target.player.powers[pw_shield] & ~SH_FIREFLOWER == SH_BUBBLEWRAP
	and mo.target.player.powers[pw_super]
		if mo.target
		and mo.target.valid
			A_Custom3DRotate(mo, 32*FRACUNIT+64, 64*FRACUNIT+64)
		end
		local superbubbleparticle2 = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		superbubbleparticle2.state = S_BLUEFIRE1
		superbubbleparticle2.frame = FF_ANIMATE
	end
	if mo
	and mo.target
	and mo.type == MT_EXEPARTICLE2
	and mo.state == mobjinfo[mo.type].spawnstate
	and mo.target.player.powers[pw_shield] & ~SH_FIREFLOWER == SH_WHIRLWIND
	and mo.target.player.powers[pw_super]
		if mo.target
		and mo.target.valid
			A_Custom3DRotate(mo, 32*FRACUNIT+64, 64*FRACUNIT+64)
		end
		local superwhirlparticle2 = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		superwhirlparticle2.state = S_BLUEFIRE1
		superwhirlparticle2.frame = FF_ANIMATE
	end
	if mo
	and mo.target
	and mo.type == MT_EXEPARTICLE2
	and mo.state == mobjinfo[mo.type].spawnstate
	and mo.target.player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PITY
	and mo.target.player.powers[pw_super]
		if mo.target
		and mo.target.valid
			A_Custom3DRotate(mo, 32*FRACUNIT+64, 64*FRACUNIT+64)
		end
		local superpityparticle2 = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		superpityparticle2.state = S_BLUEFIRE1
		superpityparticle2.frame = FF_ANIMATE
	end
	if mo
	and mo.target
	and mo.type == MT_EXEPARTICLE2
	and mo.state == mobjinfo[mo.type].spawnstate
	and mo.target.player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PINK
	and mo.target.player.powers[pw_super]
		if mo.target
		and mo.target.valid
			A_Custom3DRotate(mo, 32*FRACUNIT+64, 64*FRACUNIT+64)
		end
		local superpinkparticle2 = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		superpinkparticle2.state = S_BLUEFIRE1
		superpinkparticle2.frame = FF_ANIMATE
	end
end, MT_EXEPARTICLE2)

freeslot("SPR_ERUN", "S_EXE_SPEED")

states[S_EXE_SPEED] = {
        sprite = SPR_ERUN,
        frame = A|FF_ANIMATE|FF_PAPERSPRITE,
        tics = 10,
        var1 = 4,
        var2 = 2,
        nextstate = S_NULL
}

local function FullSpeedPower(player)
	local speedrun = P_SpawnMobj(player.mo.x + (P_RandomRange(-36,36) * player.mo.scale),
	player.mo.y + (P_RandomRange(-36,36) * player.mo.scale),
	player.mo.z + (player.mo.height/2) + (P_RandomRange(-20,20) * player.mo.scale), MT_SMOKE)
	if speedrun and speedrun.valid
		speedrun.state = S_EXE_SPEED
		speedrun.angle = player.drawangle
		speedrun.momx = 3*player.mo.momx/4
		speedrun.momy = 3*player.mo.momy/4
		speedrun.momz = 3*player.mo.momz/4
		speedrun.scale = player.mo.scale
	end
end

local function SuperSpeed(mo, trailmo, freq)
    if not mo.prevz or not mo.prevleveltime or (mo.prevleveltime ~= leveltime - 1) then
       mo.prevz = mo.z
    end
    local rmomz = mo.z - mo.prevz
    mo.prevz = mo.z
    mo.prevleveltime = leveltime
    local mospeed = R_PointToDist2(0, 0, R_PointToDist2(0, 0, mo.momx, mo.momy), rmomz)
    local dist = (mospeed/freq)
    for i = dist, 1, -1 do
        local spawnedmo = P_SpawnMobjFromMobj(mo, (mo.momx/dist)*i, (mo.momy/dist)*i, (rmomz/dist)*i, trailmo)
        spawnedmo.color = mo.color
        spawnedmo.blendmode = AST_ADD
		spawnedmo.frame = FF_TRANS50
    end
end

//Sound's
freeslot("S_PLAY_EXETIOR_EXE_DROPDASH", "S_PLAY_EXE_AIR_DOUBLE_JUMP", "S_PLAY_EXE_INFINITY_AIR_DOUBLE_JUMP", "S_PLAY_EXE_AIR_THOK", "SPR2_TRK_", "S_PLAY_TRICK", "S_PLAY_TRICK2", "S_PLAY_TRICK3", "S_PLAY_NIGHT_SPRING", "S_PLAY_NIGHT_THOK", "S_PLAY_EXETIOR_EXE_DROPDASH2", "SPR2_DRP_", "S_PLAY_EXE_AMOGUS", "S_PLAY_JUMP_POWER", "S_PLAY_EXE_HOMING", "S_PLAY_EXELAUGH", "S_PLAY_EXE_VICTORY1", "S_PLAY_EXE_VICTORY2", "S_PLAY_EXE_VICTORY3", "S_PLAY_EXE_VICTORY4", "sfx_exesnp", "sfx_exeitp", "sfx_lsde", "sfx_exetrs", "sfx_exeitp", "sfx_exedh", "S_PLAY_SPRING_POWER", "MT_SUPEREXEAURA", "S_SUPEREXEAURA")

states[S_PLAY_EXE_INFINITY_AIR_DOUBLE_JUMP] = {
        sprite = SPR_PLAY,
        frame = SPR2_LAND|FF_ANIMATE,
        tics = 20,
        var1 = 2,
        var2 = 1,
        nextstate = S_PLAY_JUMP
}

states[S_PLAY_EXE_AIR_DOUBLE_JUMP] = {
        sprite = SPR_PLAY,
        frame = SPR2_LAND|FF_ANIMATE,
        tics = 20,
        var1 = 2,
        var2 = 1,
        nextstate = S_PLAY_EXE_AIR_DOUBLE_JUMP
}

states[S_PLAY_EXE_AIR_THOK] = {
        sprite = SPR_PLAY,
        frame = SPR2_JUMP|FF_ANIMATE,
        tics = 20,
        var1 = 2,
        var2 = 1,
        nextstate = S_PLAY_EXE_AIR_THOK
}

states[S_PLAY_NIGHT_SPRING] = {
        sprite = SPR_PLAY,
        frame = SPR2_SPNG|FF_ANIMATE,
        tics = 40,
        var1 = 2,
        var2 = 1,
        nextstate = S_PLAY_NIGHT_THOK
}

states[S_PLAY_TRICK] = {
        sprite = SPR_PLAY,
        frame = SPR2_FRUN|FF_ANIMATE,
        tics = 28,
        var1 = 2,
        var2 = 1,
        nextstate = S_PLAY_FALL
}

states[S_PLAY_TRICK2] = {
        sprite = SPR_PLAY,
        frame = SPR2_TRK_|FF_ANIMATE,
        tics = 8,
        var1 = 2,
        var2 = 1,
        nextstate = S_PLAY_TRICK3
}

states[S_PLAY_TRICK3] = {
        sprite = SPR_PLAY,
        frame = SPR2_RUN_|FF_ANIMATE,
        tics = 20,
        var1 = 2,
        var2 = 1,
        nextstate = S_PLAY_FALL
}

states[S_PLAY_NIGHT_THOK] = {
        sprite = SPR_PLAY,
        frame = SPR2_JUMP|FF_ANIMATE,
        tics = 40,
        var1 = 2,
        var2 = 1,
        nextstate = S_PLAY_NIGHTS_FLOAT
}

states[S_PLAY_EXETIOR_EXE_DROPDASH] = {
        sprite = SPR_PLAY,
        frame = SPR2_DRP_|FF_ANIMATE,
        tics = 20,
        var1 = 2,
        var2 = 1,
        nextstate = S_PLAY_EXETIOR_EXE_DROPDASH
}

states[S_PLAY_EXETIOR_EXE_DROPDASH2] = {
        sprite = SPR_PLAY,
        frame = SPR2_DRP_|FF_ANIMATE,
        tics = 20,
        var1 = 2,
        var2 = 1,
        nextstate = S_PLAY_EXETIOR_EXE_DROPDASH2
}

states[S_PLAY_EXE_VICTORY4] = {
        sprite = SPR_PLAY,
        frame = SPR2_SWIM|FF_ANIMATE,
        tics = 20,
        var1 = 2,
        var2 = 1,
        nextstate = S_PLAY_EXE_VICTORY4
}

states[S_PLAY_EXE_HOMING] = {
        sprite = SPR_PLAY,
        frame = SPR2_JUMP|FF_ANIMATE,
        tics = 20,
        var1 = 2,
        var2 = 1,
        nextstate = S_PLAY_EXE_HOMING
}

states[S_PLAY_EXELAUGH] = {
        sprite = SPR_PLAY,
        frame = SPR2_FLY_|FF_ANIMATE,
        tics = 40,
        var1 = 2,
        var2 = 1,
        nextstate = S_PLAY_STND
}

states[S_PLAY_EXE_AMOGUS] = {
        sprite = SPR_PLAY,
        frame = SPR2_GLID|FF_ANIMATE,
        tics = 40,
        var1 = 2,
        var2 = 1,
        nextstate = S_PLAY_STND
}

states[S_PLAY_SPRING_POWER] = {
        sprite = SPR_PLAY,
        frame = SPR2_SPNG,
        tics = 15,
        var1 = 2,
        var2 = 1,
        nextstate = S_PLAY_JUMP_POWER
}

states[S_PLAY_JUMP_POWER] = {
        sprite = SPR_PLAY,
        frame = SPR2_JUMP|FF_ANIMATE,
        tics = 15,
        var1 = 2,
        var2 = 1,
        nextstate = S_PLAY_FALL
}


states[S_PLAY_EXE_VICTORY1] = {
        sprite = SPR_PLAY,
        frame = SPR2_CLNG,
        tics = 6,
        var1 = 2,
        var2 = 1,
        nextstate = S_PLAY_EXE_VICTORY2
}

states[S_PLAY_EXE_VICTORY2] = {
        sprite = SPR_PLAY,
        frame = SPR2_FIRE,
        tics = 15,
        var1 = 2,
        var2 = 1,
        nextstate = S_PLAY_EXE_VICTORY3
}

states[S_PLAY_EXE_VICTORY3] = {
        sprite = SPR_PLAY,
        frame = SPR2_BNCE,
        tics = 20,
        var1 = 2,
        var2 = 1,
        nextstate = S_PLAY_CLIMB
}


//Electric Double Jump in Pressing spin
freeslot("sfx_susfx7", "sfx_among", "sfx_exeha", "sfx_exeold", "S_EXE_TRAMSFORMATION", "S_EXE_BOOST1", "S_EXE_FAZERBLAST", "S_EXE_BOOST2", "SPR_BTCH", "SPR_BIG_", "SPR_YOU_", "SPR_FUCK", "SPR_FORM", "SPR_BLST", "SPR_EXES")

states[S_EXE_TRAMSFORMATION] = {
        sprite = SPR_BTCH,
        frame = A|FF_ANIMATE,
        tics = 18,
        var1 = 4,
        var2 = 2,
        nextstate = S_NULL
}

states[S_EXE_BOOST1] = {
        sprite = SPR_YOU_,
        frame = A|FF_ANIMATE|FF_PAPERSPRITE,
        tics = 18,
        var1 = 4,
        var2 = 2,
        nextstate = S_NULL
}

states[S_EXE_BOOST2] = {
        sprite = SPR_FUCK,
        frame = FF_ANIMATE|FF_PAPERSPRITE,
        tics = 18,
        var1 = 4,
        var2 = 2,
        nextstate = S_NULL
}

states[S_EXE_FAZERBLAST] = {
        sprite = SPR_BLST,
        frame = FF_ANIMATE,
        tics = 38,
        var1 = 4,
        var2 = 2,
        nextstate = S_NULL
}

local function EXEDeleteSpin(p)
     if p.spectator then return end
		if (p.mo.skin ~= "exebladeofdeath") then return end
		if P_IsObjectOnGround(p.mo) and p.pflags & PF_SPINNING and p.mo.state == S_PLAY_ROLL 
		and not (p.pflags & (PF_USEDOWN|PF_STARTDASH)) then
			p.mo.state = S_PLAY_RUN
			p.pflags = ($ & ~PF_SPINNING) | PF_USEDOWN
		return true
    end
end	

addHook("SpinSpecial", EXEDeleteSpin)

//This is Sound from spinning
freeslot("sfx_exesdh")

local execolTable = {
	[SKINCOLOR_EXEFORGE] = true
}

rawset(_G, "EXE_ColorScan", execolTable)

freeslot("SPR_CHSA", "S_EXEPARTICLE4", "MT_EXEPARTICLE4", "S_EXEPARTICLE3", "MT_EXEPARTICLE3", "sfx_fuckyu", "sfx_exetrk", "sfx_exedef", "sfx_exevc5", "sfx_clonew")

mobjinfo[MT_EXEPARTICLE3] = {
	spawnstate = S_EXEPARTICLE3,
	spawnhealth = 1000,
	height = 1,
	radius = 1,
	speed = 1,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_SCENERY,
}

states[S_EXEPARTICLE3] = {
	sprite = SPR_CHSA,
	frame = FF_ANIMATE|FF_FULLBRIGHT|TR_TRANS30,
    var1 = 8,
	var2 = 3,
	nextstate = S_NULL,
	dispoffset = 5
}

COM_AddCommand("infinityair", function(player)
	if not player.infinityair
		player.infinityair = true
		COM_BufInsertText(player,"cecho Infinity Air is a Activated")
		S_StartSound(player.mo, sfx_fuckyu)
	else
		player.infinityair = false
		COM_BufInsertText(player,"cecho Infinity Air is a Deactivated")
		S_StartSound(player.mo, sfx_fuckyu)
	end
end)

addHook("ThinkFrame", do
	for player in players.iterate
		if player.mo and player.mo.skin == "exebladeofdeath"
			local cv_chasecam = CV_FindVar("chasecam")
			local cv_chasecam2 = CV_FindVar("chasecam2")
			//Skull Shot - Button
			if not (player.mo.custom1down)
				player.mo.custom1down = 0
			end
			//Thok Jump in Spring - Button
			if not (player.mo.thokjump)
				player.mo.thokjump = 0
			end
			//Double Jump in Spring - Button
			if not (player.mo.doublejump)
				player.mo.doublejump = 0
			end
			//Trick - Adventure Style - Button
			if not (player.mo.trickadventure)
				player.mo.trickadventure = 0
			end
			if not (player.mo.trickadventure2)
				player.mo.trickadventure2 = 0
			end
			//Spin Attack - Button
			if not (player.mo.custom3down)
				player.mo.custom3down = 0
			end
			//Pose 1 - Button
			if not (player.mo.pose1down)
				player.mo.pose1down = 0
			end
			//Pose 2 - Button
			if not (player.mo.pose2down)
				player.mo.pose2down = 0
			end
			//Trick
			if not (player.mo.state_trickadventure)
				player.mo.state_trickadventure = 0
			end
			if player.mo.state_trickadventure > 0
				player.mo.state_trickadventure = $1 - 1
			end
			if player.mo.state_trickadventure > 1
				player.mo.rollangle = $1 + player.mo.momz/FRACUNIT*ANG1
			end
			if player.mo.state_trickadventure == 1
				player.mo.rollangle = 0
			end
			//Shield Ability
			if ((player.powers[pw_shield] & SH_NOSTACK) == SH_WHIRLWIND) and (player.pflags & PF_SHIELDABILITY) and (P_MobjFlip(player.mo)*player.mo.momz > 0)
				local r = FixedMul(4, player.mo.radius)
				local wind = P_SpawnMobjFromMobj(player.mo, P_RandomRange(-r,r)<<FRACBITS, P_RandomRange(-r,r)<<FRACBITS, -48<<FRACBITS, MT_PARTICLE)
				wind.frame = ($ & FF_FRAMEMASK)|TR_TRANS70
				wind.fuse = TICRATE/3
				wind.momx = player.mo.momx
				wind.momy = player.mo.momy
				wind.destscale = $/3
				P_SetObjectMomZ(wind, max(player.mo.momz*3/2, 15<<FRACBITS), false)
				continue
			end
			if player.mo.state_deffaultform == 1
				S_StartSound(player.mo, sfx_exedef)
				local deffaultform2 = P_SpawnMobj(player.mo.x+(P_RandomRange(-75,75)*player.mo.scale),player.mo.y+(P_RandomRange(-75,75)*player.mo.scale),player.mo.z+(P_RandomRange(-20,68)*player.mo.scale),MT_EXEPARTICLE)
				deffaultform2.eflags = player.mo.eflags
				P_SetObjectMomZ(deffaultform2, P_RandomRange(1,4)*player.mo.scale, true)
				deffaultform2.scale = player.mo.scale/40
				deffaultform2.destscale = $*99
				deffaultform2.scalespeed = $/8
				deffaultform2.blendmode = AST_ADD
				deffaultform2.tics = P_RandomRange(12,24)
				if leveltime == 1
					local deffaultform = P_SpawnGhostMobj(player.mo)
					deffaultform.color = SKINCOLOR_RED
					deffaultform.colorized = true
					deffaultform.ticks = 15
					deffaultform.blendmode = AST_ADD
				end
			end
			//Night Special Particles
			if (player.powers[pw_carry] == CR_NIGHTSMODE)
				local firefloatrun = P_SpawnMobj(player.mo.x+P_RandomRange(-10,10)*FRACUNIT,player.mo.y+P_RandomRange(-10,10)*FRACUNIT,player.mo.z+player.mo.height-15*FRACUNIT+P_RandomRange(-10,10)*FRACUNIT, MT_SPINDUST)
				firefloatrun.state = S_SPINFIRE1
				firefloatrun.fuse = 7
				firefloatrun.scale = player.mo.scale/2
				firefloatrun.blendmode = AST_ADD
				if (leveltime & 3) == 1
					local nightsghost = P_SpawnGhostMobj(player.mo)
					nightsghost.fuse = 6
					nightsghost.color = SKINCOLOR_RED
					nightsghost.colorized = true
					nightsghost.blendmode = AST_ADD
				end
				//Voice Number 5 - Oh. Okay. - In a Night Special
				if leveltime == 1
					S_StartSound(player.mo, sfx_exevc5)
				end
			end
			//Pose 1 - Laugh
			if (player.cmd.buttons & BT_CUSTOM2 and player.cmd.buttons & BT_TOSSFLAG)
			and (player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WAIT)
			and not player.weapondelay
			and player.playerstate == PST_LIVE
			and not player.exiting
			and not player.powers[pw_carry]
			and not (player.pflags & PF_STASIS)
			and not (player.mo.state == S_PLAY_SUPER_TRANS1)
			and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
			and not (player.pflags & PF_SPINNING)
			and player.mo.pose1down == 0
				player.mo.pose1down = 1
				player.weapondelay = 3*TICRATE
				player.mo.state = S_PLAY_EXELAUGH
				S_StartSound(player.mo, sfx_exeold)
			end
			//Pose 2 - AMOGUS
			if (player.cmd.buttons & BT_ATTACK and player.cmd.buttons & BT_TOSSFLAG)
			and (player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WAIT)
			and not player.weapondelay
			and player.playerstate == PST_LIVE
			and not player.exiting
			and not player.powers[pw_carry]
			and not (player.pflags & PF_STASIS)
			and not (player.mo.state == S_PLAY_SUPER_TRANS1)
			and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
			and not (player.pflags & PF_SPINNING)
			and player.mo.pose2down == 0
				player.mo.pose2down = 1
				player.weapondelay = 3*TICRATE
				player.mo.state = S_PLAY_EXE_AMOGUS
				S_StartSound(player.mo, sfx_among)
			end
			//Skull Shot
			if (player.cmd.buttons & BT_CUSTOM1)
			and not (player.mo.state == S_PLAY_PAIN)
			and not player.weapondelay
			and player.playerstate == PST_LIVE
			and not player.exiting
			and not player.powers[pw_carry]
			and not (player.pflags & PF_STASIS)
			and not (player.mo.state == S_PLAY_SUPER_TRANS1)
			and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
			and not (player.pflags & PF_SPINNING)
			and player.mo.custom1down == 0
				player.mo.custom1down = 1
				player.weapondelay = 3*TICRATE
				local hellowenskul = P_SpawnGhostMobj(player.mo)
				hellowenskul.color = SKINCOLOR_RED
				hellowenskul.colorized = true
				hellowenskul.blendmode = AST_ADD
				hellowenskul.flags2 = $|MF2_SHADOW
				local cacofire = P_SpawnGhostMobj(player.mo)
				cacofire.state = S_CACOFIRE_EXPLODE1
				P_SpawnPlayerMissile(player.mo, MT_SKULSHOT, MF2_SCATTER)
				local hellowenskulshot1 = P_SPMAngle(player.mo, MT_SKULSHOT, player.mo.angle-ANG2, 1, MF2_SCATTER)
				local hellowenskulshot2 = P_SPMAngle(player.mo, MT_SKULSHOT, player.mo.angle+ANG2, 1, MF2_SCATTER)
			end
			//Spindash Power!
			if (player.pflags & PF_STARTDASH)
			and not player.exiting
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
			and not (player.mo.eflags & MFE_UNDERWATER)
				local exedust = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z + ((player.mo.eflags & MFE_VERTICALFLIP)/MFE_VERTICALFLIP * (player.mo.height - mobjinfo[MT_SPINDUST].height)), MT_SPINDUST)
				exedust.state = S_SPINDUST_FIRE1
				exedust.tics = 8
				exedust.eflags = $1 | (player.mo.eflags & MFE_VERTICALFLIP)
				exedust.scale = player.mo.scale >> 1
				exedust.destscale = player.mo.scale << 3
				exedust.scalespeed = FixedMul(exedust.scalespeed, player.mo.scale) -- scale the scaling speed!
				P_SetObjectMomZ(exedust, player.dashspeed/20, false)				
				P_InstaThrust(exedust, player.mo.angle+(P_RandomRange(-ANG30/FRACUNIT, ANG30/FRACUNIT)*FRACUNIT), FixedMul(-player.runspeed/12-1*FRACUNIT-P_RandomByte()<<11, player.mo.scale))
				P_TryMove(exedust, exedust.x+exedust.momx, exedust.y+exedust.momy, true)
				player.charflags = $1|SF_NOSPINDASHDUST
			else
				player.charflags = $1 & ~SF_NOSPINDASHDUST
			end
			//Spinning to fire's
			if (P_IsObjectOnGround(player.mo)) 
			and (player.mo.state == S_PLAY_ROLL)
			and (player.pflags & PF_SPINNING)
				local firefloat = P_SpawnMobj(player.mo.x+P_RandomRange(-10,10)*FRACUNIT,player.mo.y+P_RandomRange(-10,10)*FRACUNIT,player.mo.z+player.mo.height-15*FRACUNIT+P_RandomRange(-10,10)*FRACUNIT, MT_SPINDUST)
				firefloat.state = S_SPINFIRE1
				firefloat.fuse = 7
				firefloat.scale = player.mo.scale/2
			end
			if (P_IsObjectOnGround(player.mo))
				player.mo.spritexscale = FRACUNIT
				player.mo.spriteyscale = FRACUNIT
				player.charflags = $1|SF_RUNONWATER
			end
			//Spring check.
			if (player.powers[pw_justsprung] or player.mo.eflags & MFE_SPRUNG)
                player.springuse = true
			elseif (P_IsObjectOnGround(player.mo))
                player.springuse = false
			end
			
			//DoubleJump in spring - button: Spin
			if (player.cmd.buttons & BT_SPIN)
			and not (P_IsObjectOnGround(player.mo))
			and not (player.pflags & PF_JUMPED)
			and (player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL)
			and player.mo.doublejump == 0
			and not player.infinityair
				player.mo.doublejump = 1
				if player.springuse
					player.pflags = $1|PF_JUMPED
					P_SetObjectMomZ(player.mo, 8*FRACUNIT)
 					S_StartSound(player.mo, sfx_jump)
					player.springuse = false
					player.mo.state = S_PLAY_EXE_AIR_DOUBLE_JUMP
				end
			end
			//Thok in Spring - button: Jump
			if (player.cmd.buttons & BT_JUMP)
			and not (P_IsObjectOnGround(player.mo))
			and not (player.pflags & PF_JUMPED)
			and (player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL)
			and player.mo.thokjump == 0
			and not player.infinityair
				player.mo.thokjump = 1
				if player.springuse
					player.pflags = $1|PF_JUMPED
					player.pflags = $1|PF_THOKKED
					player.mo.state = S_PLAY_JUMP
					local jumpcacofire = P_SpawnGhostMobj(player.mo)
					jumpcacofire.state = S_CACOFIRE_EXPLODE1
					S_StartSound(player.mo, sfx_thok)
					player.springuse = false
					P_SetObjectMomZ(player.mo, 1*FRACUNIT)
					if (player.mo.eflags & MFE_UNDERWATER)
						P_InstaThrust(player.mo, player.mo.angle, 30*FRACUNIT)
					else
						P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT)
					end
				end
			end
			
			//Infinity
			//DoubleJump in spring - button: Spin
			if (player.cmd.buttons & BT_SPIN)
			and not (P_IsObjectOnGround(player.mo))
			and not (player.pflags & PF_JUMPED)
			and (player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL)
			and player.mo.doublejump == 0
			and player.infinityair == true
				player.mo.doublejump = 1
				if player.springuse
					player.pflags = $1|PF_JUMPED
					P_SetObjectMomZ(player.mo, 8*FRACUNIT)
 					S_StartSound(player.mo, sfx_jump)
					player.mo.state = S_PLAY_EXE_INFINITY_AIR_DOUBLE_JUMP
				end
			end
			//Thok in Spring - button: Jump
			if (player.cmd.buttons & BT_JUMP)
			and not (P_IsObjectOnGround(player.mo))
			and not (player.pflags & PF_JUMPED)
			and (player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL)
			and player.mo.thokjump == 0
			and player.infinityair == true
				player.mo.thokjump = 1
				if player.springuse
					player.pflags = $1|PF_JUMPED
					player.pflags = $1|PF_THOKKED
					player.mo.state = S_PLAY_JUMP
					local jumpcacofire = P_SpawnGhostMobj(player.mo)
					jumpcacofire.state = S_CACOFIRE_EXPLODE1
					S_StartSound(player.mo, sfx_thok)
					P_SetObjectMomZ(player.mo, 1*FRACUNIT)
					if (player.mo.eflags & MFE_UNDERWATER)
						P_InstaThrust(player.mo, player.mo.angle, 30*FRACUNIT)
					else
						P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT)
					end
				end
			end
			
			
			//Adventure Jump
			if (player.pflags & PF_JUMPED)
				player.pflags = $1 & ~PF_SPINNING
			end
			//Trick Advance Style - Coop
			if (player.cmd.buttons & BT_SPIN)
			and not (P_IsObjectOnGround(player.mo))
			and not (player.pflags & PF_JUMPED)
			and (player.mo.state == S_PLAY_SPRING)
			and player.mo.trickadventure == 0
			and not (player.mo.eflags & MFE_SPRUNG)
			and not (CBW_Battle)
			and not ((gametype == GT_TEAMMATCH) or (gametype == GT_CTF) or (gametype == GT_MATCH) or (gametype == GT_TAG) or (gametype ==  GT_HIDEANDSEEK) or (gametype == GT_EXEAMOGUS) or (gametype == GT_EXESURVIVAL) or (gametype == GT_EXEVIRUS))
				if not player.springuse
					if not (player.mo.eflags & MFE_TOUCHWATER)
						player.mo.trickadventure = 1
						P_AddPlayerScore(player, 50)
						player.mo.state_trickadventure = 38
						player.springuse = false
						player.mo.state = S_PLAY_TRICK2
						S_StartSound(player.mo, sfx_exetrk)
						S_StartSound(player.mo, sfx_clonew)
						if player.powers[pw_super]
							P_InstaThrust(player.mo, player.mo.angle, player.speed+4)
						else
							P_InstaThrust(player.mo, player.mo.angle, player.speed+2)
						end
					end
				end
			end
			//Trick 2 Advance Style - Coop
			if (player.cmd.buttons & BT_SPIN)
			and not (P_IsObjectOnGround(player.mo))
			and not (player.pflags & PF_JUMPED)
			and (player.mo.state == S_PLAY_ROLL)
			and player.mo.trickadventure2 == 0
			and not (player.mo.eflags & MFE_SPRUNG)
			and not (CBW_Battle)
			and not ((gametype == GT_TEAMMATCH) or (gametype == GT_CTF) or (gametype == GT_MATCH) or (gametype == GT_TAG) or (gametype ==  GT_HIDEANDSEEK) or (gametype == GT_EXEAMOGUS) or (gametype == GT_EXESURVIVAL) or (gametype == GT_EXEVIRUS))
				if not player.springuse
					if not (player.mo.eflags & MFE_TOUCHWATER)
						player.mo.trickadventure2 = 1
						P_AddPlayerScore(player, 50)
						player.springuse = false
						player.mo.state = S_PLAY_TRICK
						S_StartSound(player.mo, sfx_exetrk)
						if player.powers[pw_super]
							P_InstaThrust(player.mo, player.mo.angle, player.speed+4)
						else
							P_InstaThrust(player.mo, player.mo.angle, player.speed+2)
						end
					end
				end
			end
			//Trick Advance Style - Battle Mode Support
			if (player.cmd.buttons & BT_SPIN)
			and not (P_IsObjectOnGround(player.mo))
			and not (player.pflags & PF_JUMPED)
			and (player.mo.state == S_PLAY_SPRING)
			and player.mo.trickadventure == 0
			and not (player.mo.eflags & MFE_SPRUNG)
			and not ((gametype == GT_TEAMMATCH) or (gametype == GT_CTF) or (gametype == GT_MATCH) or (gametype == GT_TAG) or (gametype ==  GT_HIDEANDSEEK) or (gametype == GT_EXEAMOGUS) or (gametype == GT_EXESURVIVAL) or (gametype == GT_EXEVIRUS))
			and (CBW_Battle)
				if not player.springuse
					if not (player.mo.eflags & MFE_TOUCHWATER)
						player.mo.trickadventure = 1
						player.mo.state_trickadventure = 38
						player.springuse = false
						player.mo.state = S_PLAY_TRICK2
						S_StartSound(player.mo, sfx_exetrk)
						S_StartSound(player.mo, sfx_clonew)
						if player.powers[pw_super]
							P_InstaThrust(player.mo, player.mo.angle, player.speed+4)
						else
							P_InstaThrust(player.mo, player.mo.angle, player.speed+2)
						end
					end
				end
			end
			//Trick 2 Advance Style - Battle Mode Support
			if (player.cmd.buttons & BT_SPIN)
			and not (P_IsObjectOnGround(player.mo))
			and not (player.pflags & PF_JUMPED)
			and (player.mo.state == S_PLAY_ROLL)
			and player.mo.trickadventure2 == 0
			and not (player.mo.eflags & MFE_SPRUNG)
			and not ((gametype == GT_TEAMMATCH) or (gametype == GT_CTF) or (gametype == GT_MATCH) or (gametype == GT_TAG) or (gametype ==  GT_HIDEANDSEEK) or (gametype == GT_EXEAMOGUS) or (gametype == GT_EXESURVIVAL) or (gametype == GT_EXEVIRUS))
			and (CBW_Battle)
				if not player.springuse
					if not (player.mo.eflags & MFE_TOUCHWATER)
						player.mo.trickadventure2 = 1
						player.springuse = false
						player.mo.state = S_PLAY_TRICK
						S_StartSound(player.mo, sfx_exetrk)
						if player.powers[pw_super]
							P_InstaThrust(player.mo, player.mo.angle, player.speed+4)
						else
							P_InstaThrust(player.mo, player.mo.angle, player.speed+2)
						end
					end
				end
			end
			//Trick Advance Style - MiniGames
			if (player.cmd.buttons & BT_SPIN)
			and not (P_IsObjectOnGround(player.mo))
			and not (player.pflags & PF_JUMPED)
			and (player.mo.state == S_PLAY_SPRING)
			and player.mo.trickadventure == 0
			and not (player.mo.eflags & MFE_SPRUNG)
			and ((gametype == GT_TEAMMATCH) or (gametype == GT_CTF) or (gametype == GT_MATCH) or (gametype == GT_TAG) or (gametype ==  GT_HIDEANDSEEK) or (gametype == GT_EXEAMOGUS) or (gametype == GT_EXESURVIVAL) or (gametype == GT_EXEVIRUS))
			and not (CBW_Battle)
				if not player.springuse
					if not (player.mo.eflags & MFE_TOUCHWATER)
						player.mo.trickadventure = 1
						player.mo.state_trickadventure = 38
						player.springuse = false
						player.mo.state = S_PLAY_TRICK2
						S_StartSound(player.mo, sfx_exetrk)
						S_StartSound(player.mo, sfx_clonew)
						if player.powers[pw_super]
							P_InstaThrust(player.mo, player.mo.angle, player.speed+4)
						else
							P_InstaThrust(player.mo, player.mo.angle, player.speed+2)
						end
					end
				end
			end
			//Trick 2 Advance Style - MiniGames
			if (player.cmd.buttons & BT_SPIN)
			and not (P_IsObjectOnGround(player.mo))
			and not (player.pflags & PF_JUMPED)
			and (player.mo.state == S_PLAY_ROLL)
			and player.mo.trickadventure2 == 0
			and not (player.mo.eflags & MFE_SPRUNG)
			and ((gametype == GT_TEAMMATCH) or (gametype == GT_CTF) or (gametype == GT_MATCH) or (gametype == GT_TAG) or (gametype ==  GT_HIDEANDSEEK) or (gametype == GT_EXEAMOGUS) or (gametype == GT_EXESURVIVAL))
			and not (CBW_Battle)
				if not player.springuse
					if not (player.mo.eflags & MFE_TOUCHWATER)
						player.mo.trickadventure2 = 1
						player.springuse = false
						player.mo.state = S_PLAY_TRICK
						S_StartSound(player.mo, sfx_exetrk)
						if player.powers[pw_super]
							P_InstaThrust(player.mo, player.mo.angle, player.speed+4)
						else
							P_InstaThrust(player.mo, player.mo.angle, player.speed+2)
						end
					end
				end
			end
			//Trick 2 Advance Style - EXE Virus
			if (player.cmd.buttons & BT_SPIN)
			and not (P_IsObjectOnGround(player.mo))
			and not (player.pflags & PF_JUMPED)
			and (player.mo.state == S_PLAY_SPRING)
			and player.mo.trickadventure == 0
			and not (player.mo.eflags & MFE_SPRUNG)
			and (gametype == GT_EXEVIRUS)
			and not (CBW_Battle)
				if not player.springuse
					if not (player.mo.eflags & MFE_TOUCHWATER)
						player.mo.trickadventure = 1
						player.mo.state_trickadventure = 38
						player.springuse = false
						player.mo.state = S_PLAY_TRICK2
						S_StartSound(player.mo, sfx_exetrk)
						S_StartSound(player.mo, sfx_clonew)
						if player.powers[pw_super]
							P_InstaThrust(player.mo, player.mo.angle, player.speed+4)
						else
							P_InstaThrust(player.mo, player.mo.angle, player.speed+2)
						end
					end
				end
			end
			//Trick 2 Advance Style - EXE Virus
			if (player.cmd.buttons & BT_SPIN)
			and not (P_IsObjectOnGround(player.mo))
			and not (player.pflags & PF_JUMPED)
			and (player.mo.state == S_PLAY_ROLL)
			and player.mo.trickadventure2 == 0
			and not (player.mo.eflags & MFE_SPRUNG)
			and (gametype == GT_EXEVIRUS)
			and not (CBW_Battle)
				if not player.springuse
					if not (player.mo.eflags & MFE_TOUCHWATER)
						player.mo.trickadventure2 = 1
						player.springuse = false
						player.mo.state = S_PLAY_TRICK
						S_StartSound(player.mo, sfx_exetrk)
						if player.powers[pw_super]
							P_InstaThrust(player.mo, player.mo.angle, player.speed+4)
						else
							P_InstaThrust(player.mo, player.mo.angle, player.speed+2)
						end
					end
				end
			end
			//Trick State particles	
			if (player.mo.state == S_PLAY_TRICK or player.mo.state == S_PLAY_TRICK2 or player.mo.state == S_PLAY_TRICK3)
				player.pflags = $1 & ~PF_SHIELDABILITY
				player.pflags = $1 & ~PF_SPINNING
				local firefloat = P_SpawnMobj(player.mo.x+P_RandomRange(-10,10)*FRACUNIT,player.mo.y+P_RandomRange(-10,10)*FRACUNIT,player.mo.z+player.mo.height-15*FRACUNIT+P_RandomRange(-10,10)*FRACUNIT, MT_SPINDUST)
				firefloat.state = S_SPINFIRE1
				firefloat.fuse = 7
				firefloat.scale = player.mo.scale/2
				local adventuretrickexeversion = P_SpawnGhostMobj(player.mo)
				adventuretrickexeversion.color = SKINCOLOR_RED
				adventuretrickexeversion.colorized = true
				adventuretrickexeversion.fuse = 4
				adventuretrickexeversion.frame = ($1 & ~FF_TRANSMASK)|FF_TRANS40
				adventuretrickexeversion.eflags = player.mo.eflags & MFE_VERTICALFLIP
			end
			//Fix a Rollagnle
			if not (player.mo.state == S_PLAY_TRICK or player.mo.state == S_PLAY_TRICK2 or player.mo.state == S_PLAY_TRICK3)
			and not player.powers[pw_carry]
				player.mo.rollangle = 0
			end
			//State - DropDash
			if (player.mo.state == S_PLAY_EXETIOR_EXE_DROPDASH)
				player.pflags = $1|PF_JUMPED
				if (leveltime % 5) == 8
					local ghs = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THOK)
					ghs.frame = TR_TRANS50
					ghs.destscale = $*99
					ghs.scalespeed = $*6
					ghs.tics = 6
					ghs.blendmode = AST_ADD
					ghs.colorized = true
				end
				if (leveltime % 2) == 3
				or (leveltime % 1) == 5
					ghs.color = SKINCOLOR_RED
				end
				if (leveltime % 3) == 1
					local dropdashbreaks = P_SpawnGhostMobj(player.mo)
					dropdashbreaks.color = SKINCOLOR_RED
					dropdashbreaks.colorized = true
					dropdashbreaks.ticks = 15
					dropdashbreaks.blendmode = AST_ADD
					dropdashbreaks.fuse = 4
				end
			end
			if (player.mo.state == S_PLAY_RIDE or player.mo.state == S_PLAY_EDGE or player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_RUN or player.mo.state == S_PLAY_EXETIOR_EXE_DROPDASH or player.mo.state == S_PLAY_EXETIOR_EXE_DROPDASH2 or player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL or player.mo.state == S_PLAY_SUPER_TRANS1)
				player.mo.spritexscale = FRACUNIT
				player.mo.spriteyscale = FRACUNIT
				player.charflags = $1|SF_RUNONWATER
			end
			//Crumble
			if ((player.mo.eflags & MFE_JUSTHITFLOOR) or P_IsObjectOnGround(player.mo))
			and (player.rebound)
				local sectorz = R_PointInSubsector(player.mo.x, player.mo.y).sector
				for fof in sectorz.ffloors()
					if (fof.flags & FF_EXISTS) and ((fof.flags & FF_STRONGBUST) or (fof.flags & FF_BUSTUP))
					and not (player.mo.z-99*FRACUNIT >= fof.topheight)
					and not (player.mo.z+99*FRACUNIT+player.mo.height < fof.bottomheight)
						local line = fof.master
						EV_CrumbleChain(fof)
						S_StartSound(player.mo, sfx_s3k5f)
						player.mo.state = S_PLAY_EXETIOR_EXE_DROPDASH
						P_SetObjectMomZ(player.mo, 8*FRACUNIT)
						player.rebound = false
						player.pflags = $1|PF_JUMPED
						if (line.flags & ML_EFFECT5)
							P_LinedefExecute(P_AproxDistance(line.dx, line.dy) >> FRACBITS, player.mo, fof.target)
						end
					end
				end
			end
			if (player.mo.state == S_PLAY_SPINDASH)
				local spindashpower = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_EXEPARTICLE2)
				spindashpower.blendmode = AST_ADD
				spindashpower.tics = P_RandomRange(12,24)
				spindashpower.color = SKINCOLOR_SAPPHIRE
				spindashpower.colorized = true
				spindashpower.target = player.mo
				spindashpower.angle = P_RandomRange(0, 360)*ANG1
				spindashpower.movedir = P_RandomRange(0, 360)*ANG1
				local spindashghost = P_SpawnGhostMobj(player.mo)
				spindashghost.destscale = $*99
				spindashghost.blendmode = AST_ADD
				P_InstaThrust(player.mo, player.mo.angle, 10)
				local trail2 = P_SpawnGhostMobj(player.mo)
				trail2.state = S_THOK
				trail2.scale = (FRACUNIT * 8/10)
				trail2.destscale = 0
				trail2.fuse = 13
				trail2.momz = 3*FRACUNIT
				P_Thrust(trail2, player.mo.angle, 90*FRACUNIT)
				if (player.mo and EXE_ColorScan[player.skincolor])
					spindashghost.color = SKINCOLOR_RED
					spindashghost.colorized = true
					trail2.color = SKINCOLOR_RED
			elseif not (player.mo and EXE_ColorScan[player.skincolor])
					spindashghost.color = player.mo.color
					spindashghost.colorized = true
					trail2.color = player.mo.color
				end
			end
			if (player.mo.eflags & MFE_JUSTHITFLOOR)
			and not (player.mo.eflags & MFE_UNDERWATER)
			and (player.mo.eflags & MFE_ONGROUND)
			and not (player.mo.eflags & MFE_TOUCHWATER)
			and not (player.mo.eflags & MFE_SPRUNG)
			and not (player.mo.flags & FF_EXISTS) 
			and not (player.mo.flags & FF_STRONGBUST) 
			and not (player.mo.flags & FF_BUSTUP)
			and not player.powers[pw_justlaunched]
			and player.playerstate == PST_LIVE
				if player.powers[pw_super]
					S_StartSound(player.mo, sfx_s3k5f)
					P_StartQuake(79*FRACUNIT, 3)
				elseif not player.powers[pw_super]
					S_StartSound(player.mo, sfx_s3k4c)
				end
			end
			if (player.mo.state == S_PLAY_EXELAUGH or player.mo.state == S_PLAY_EXE_AMOGUS)
				A_Thrust(player.mo, 0, 1)
			end
			if (player.mo.state == S_PLAY_PAIN)
				player.mo.spritexscale = FRACUNIT
				player.mo.spriteyscale = FRACUNIT
				player.charflags = $1|SF_RUNONWATER
			end
			if (player.mo.state == S_PLAY_WAIT)
				local waitanimation = P_SpawnMobj(player.mo.x+(P_RandomRange(-75,75)*player.mo.scale),player.mo.y+(P_RandomRange(-75,75)*player.mo.scale),player.mo.z+(P_RandomRange(-20,68)*player.mo.scale),MT_EXEPARTICLE)
				waitanimation.eflags = player.mo.eflags
				P_SetObjectMomZ(waitanimation, P_RandomRange(1,4)*player.mo.scale, true)
				waitanimation.scale = player.mo.scale/40
				waitanimation.destscale = $*99
				waitanimation.scalespeed = $/8
				waitanimation.blendmode = AST_ADD
				waitanimation.tics = P_RandomRange(12,24)
			end
			//Pose Victory
			if (player.exiting)
			and player.speed == 0
			and P_IsObjectOnGround(player.mo)
			and (player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WAIT or player.mo.state == S_PLAY_EDGE or player.mo.state == S_PLAY_EXELAUGH)
				//Bonus Type from boss defeated
				if mapheaderinfo[gamemap].bonustype == 1
					player.mo.state = S_PLAY_EXE_VICTORY4
					S_StartSound(player.mo, sfx_exerr2)
				//This is just a level exiting
				elseif mapheaderinfo[gamemap].bonustype == 0
					player.mo.state = S_PLAY_EXE_VICTORY1
					S_StartSound(player.mo, sfx_exeha)
				end
			end
			if player.powers[pw_justsprung]
			or (player.mo.eflags & MFE_SPRUNG)
				player.mo.spritexscale = FRACUNIT
				player.mo.spriteyscale = FRACUNIT
			end
			//Anti-bug.
			if player.powers[pw_super] and player.hyperform == true
			and not (player.mo.state == S_PLAY_SPINDASH or player.mo.state == S_PLAY_WAIT)
				local hyperchaos = P_SpawnMobj(player.mo.x+(P_RandomRange(-75,75)*player.mo.scale),player.mo.y+(P_RandomRange(-75,75)*player.mo.scale),player.mo.z+(P_RandomRange(-20,68)*player.mo.scale),MT_EXEPARTICLE)
				hyperchaos.eflags = player.mo.eflags
				P_SetObjectMomZ(hyperchaos, P_RandomRange(1,4)*player.mo.scale, true)
				hyperchaos.scale = player.mo.scale/40
				hyperchaos.destscale = $*99
				hyperchaos.scalespeed = $/8
				hyperchaos.blendmode = AST_ADD
				hyperchaos.tics = P_RandomRange(12,24)
			end
			//Tramsformation
			if (player.mo.state == S_PLAY_SUPER_TRANS1 or player.mo.state == S_PLAY_SUPER_TRANS3)
			and player.powers[pw_super]
				local tramsformation = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
				tramsformation.state = S_EXE_TRAMSFORMATION
				tramsformation.angle = player.mo.angle
				tramsformation.fuse = 2
			end
			//Form's in ability
			if player.powers[pw_super] and not player.hyperform
				player.charability = CA_FLOAT
				player.charflags = $1 & ~SF_MULTIABILITY
			elseif not player.powers[pw_super] and not player.hyperform 
				player.charability = CA_SLOWFALL
				player.charflags = $1 & ~SF_MULTIABILITY
			elseif player.powers[pw_super] and player.hyperform == true
				player.charability = CA_FLOAT
				player.charflags = $1|SF_MULTIABILITY
			end
			if player.speed >= player.runspeed
			and not (player.mo.state == S_PLAY_TRICK or player.mo.state == S_PLAY_TRICK2 or player.mo.state == S_PLAY_FLOAT or player.mo.state == S_PLAY_FLOAT_RUN or player.mo.state == S_PLAY_JUMP or player.mo.state == S_PLAY_SPRING_POWER or player.mo.state == S_PLAY_JUMP_POWER or player.mo.state == S_PLAY_SPINDASH)
					local ghost = P_SpawnGhostMobj(player.mo)
					if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_NONE
					and not player.powers[pw_super]
						ghost.fuse = 4
					elseif player.powers[pw_shield]
					and player.powers[pw_super]
						ghost.fuse = 6
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PITY
					and not player.powers[pw_super]
						ghost.color = SKINCOLOR_GREEN
						ghost.fuse = 4
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PINK
					and not player.powers[pw_super]
						ghost.color = SKINCOLOR_ROSY
						ghost.fuse = 4
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ELEMENTAL
					and not player.powers[pw_super]
						ghost.color = SKINCOLOR_MINT
						ghost.fuse = 4
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FLAMEAURA
					and not player.powers[pw_super]
						ghost.color = SKINCOLOR_KETCHUP
						ghost.fuse = 4
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ARMAGEDDON
					and not player.powers[pw_super]
						ghost.color = SKINCOLOR_RED
						ghost.fuse = 4
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ATTRACT
					and not player.powers[pw_super]
						ghost.color = SKINCOLOR_YELLOW
						ghost.fuse = 4
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_THUNDERCOIN
					and not player.powers[pw_super]
						ghost.color = SKINCOLOR_GOLD
						ghost.fuse = 4
					elseif (player.powers[pw_shield] == SH_FORCE|1)
					and not player.powers[pw_super]
						ghost.color = SKINCOLOR_PURPLE
						ghost.fuse = 6
					elseif (player.powers[pw_shield] == SH_FORCE)
					and not player.powers[pw_super]
						ghost.color = SKINCOLOR_PASTEL
						ghost.fuse = 4
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_BUBBLEWRAP
					and not player.powers[pw_super]
						ghost.color = SKINCOLOR_SKY
						ghost.fuse = 4
					elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_WHIRLWIND
					and not player.powers[pw_super]
						ghost.color = SKINCOLOR_WHITE
						ghost.fuse = 4
					end
					if player.mo.eflags & MFE_VERTICALFLIP
					ghost.eflags = $1|MFE_VERTICALFLIP
					ghost.flags2 = $1|MF2_OBJECTFLIP
				end
			end
			if not(P_IsObjectOnGround(player.mo))
			and not player.powers[pw_carry]
			and player.playerstate == PST_LIVE
			and (player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_RUN)
				if player.powers[pw_justlaunched]
					player.mo.state = S_PLAY_SPRING
					S_StartSound(player.mo, sfx_s3ka0)
				else
					player.mo.state = S_PLAY_FALL
					S_StartSound(player.mo, sfx_s3k51)
				end
			end
			//Speed in 60
			if player.speed >= player.runspeed
			and (player.speed > 60*FRACUNIT)
				FullSpeedPower(player)
			end
			//Jump
			if (player.mo.state == S_PLAY_JUMP or player.mo.state == S_PLAY_JUMP_POWER)
				player.mo.spritexscale = FRACUNIT+FixedDiv(player.mo.momz/96,player.mo.scale)
				player.mo.spriteyscale = FRACUNIT-FixedDiv(player.mo.momz/96,player.mo.scale)
			end
			//In Jumped from
			if (player.mo.state == S_PLAY_JUMP or player.mo.state == S_PLAY_JUMP_POWER)
				local trail = P_SpawnGhostMobj(player.mo)
				for i = 0,9
					trail.fuse = 13
					trail.state = S_THOK
					trail.scale = (FRACUNIT * 8/10) - (i * FRACUNIT/320)
					trail.destscale = 0
					trail.blendmode = AST_ADD
					trail.color = player.mo.color
					trail.spritexscale = player.mo.spritexscale
					trail.spriteyscale = player.mo.spriteyscale
				end
			end
			//BonusType
			if mapheaderinfo[gamemap].bonustype == 1 then
				if leveltime == 1
					S_StartSound(player.mo, sfx_exevce)
				end
			end
			if (player.mo.state == S_PLAY_SPRING_POWER)
				SuperSpeed(player.mo, MT_THOK, 4*FRACUNIT)
				local springpower = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_EXEPARTICLE2)
				springpower.blendmode = AST_ADD
				springpower.tics = P_RandomRange(12,24)
				springpower.color = SKINCOLOR_SAPPHIRE
				springpower.colorized = true
				springpower.target = player.mo
				springpower.angle = P_RandomRange(0, 360)*ANG1
				springpower.movedir = P_RandomRange(0, 360)*ANG1
				player.mo.spritexscale = FRACUNIT
				player.mo.spriteyscale = FRACUNIT
			end
			//Exit Level is to shield's
			if player.powers[pw_shield]
			and (player.exiting)
				if player.shieldscale < skins[player.mo.skin].shieldscale
					player.shieldscale = $+(skins[player.mo.skin].shieldscale/7)
			elseif player.shieldscale > skins[player.mo.skin].shieldscale
					player.shieldscale = skins[player.mo.skin].shieldscale
				end
			end
			//Inv Shield
			if player.powers[pw_shield]
			and not (player.exiting)
				player.shieldscale = 0
			end
			//Remake Exetior - Spindash Balance
			if not player.powers[pw_carry]
				if (player.mo.eflags & MFE_UNDERWATER)
					player.maxdash = 25*FRACUNIT
					player.maxdash = 60*FRACUNIT
				else
					player.maxdash = 60*FRACUNIT
					player.maxdash = 100*FRACUNIT
				end
			end
			//Slow Fall
			if (player.charability == CA_SLOWFALL or player.charability == CA_FLOAT)
			and (player.mo.state == S_PLAY_FLOAT or player.mo.state == S_PLAY_FLOAT_RUN)
				local firefloatrun = P_SpawnMobj(player.mo.x+P_RandomRange(-10,10)*FRACUNIT,player.mo.y+P_RandomRange(-10,10)*FRACUNIT,player.mo.z+player.mo.height-15*FRACUNIT+P_RandomRange(-10,10)*FRACUNIT, MT_SPINDUST)
				firefloatrun.state = S_SPINFIRE1
				firefloatrun.fuse = 7
				firefloatrun.scale = player.mo.scale/2
				firefloatrun.blendmode = AST_ADD
				player.mo.spritexscale = FRACUNIT
				player.mo.spriteyscale = FRACUNIT
				S_StartSound(player.mo, sfx_fire)
				if (leveltime & 3) == 1
					local slowdash = P_SpawnGhostMobj(player.mo)
					slowdash.color = SKINCOLOR_RED
					slowdash.colorized = true
					slowdash.blendmode = AST_ADD
				end
			end
			//Fix a Shield
			if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ELEMENTAL
			and not player.powers[pw_shield]
			and not (player.mo.state == S_PLAY_SPINDASH)
			and not (player.exiting)
				local elemental = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_EXEPARTICLE2)
				elemental.blendmode = AST_ADD
				elemental.tics = P_RandomRange(12,24)
				elemental.color = SKINCOLOR_MINT
				elemental.colorized = true
				elemental.target = player.mo
				elemental.angle = P_RandomRange(0, 360)*ANG1
				elemental.movedir = P_RandomRange(0, 360)*ANG1
				player.shieldscale = 0
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					elemental.flags2 = $|MF2_DONTDRAW
				end
		elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FLAMEAURA
			and not player.powers[pw_shield]
			and not (player.mo.state == S_PLAY_SPINDASH)
			and not (player.exiting)
				local flame = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_EXEPARTICLE2)
				flame.blendmode = AST_ADD
				flame.tics = P_RandomRange(12,24)
				flame.color = SKINCOLOR_KETCHUP
				flame.colorized = true
				flame.target = player.mo
				flame.angle = P_RandomRange(0, 360)*ANG1
				flame.movedir = P_RandomRange(0, 360)*ANG1
				player.shieldscale = 0
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					flame.flags2 = $|MF2_DONTDRAW
				end
		elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ARMAGEDDON
			and not player.powers[pw_shield]
			and not (player.mo.state == S_PLAY_SPINDASH)
			and not (player.exiting)
				local armaggedon = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_EXEPARTICLE2)
				armaggedon.blendmode = AST_ADD
				armaggedon.tics = P_RandomRange(12,24)
				armaggedon.color = SKINCOLOR_SALMON
				armaggedon.colorized = true
				armaggedon.target = player.mo
				armaggedon.angle = P_RandomRange(0, 360)*ANG1
				armaggedon.movedir = P_RandomRange(0, 360)*ANG1
				player.shieldscale = 0
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					armaggedon.flags2 = $|MF2_DONTDRAW
				end
		elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PITY
			and not player.powers[pw_shield]
			and not (player.mo.state == S_PLAY_SPINDASH)
			and not (player.exiting)
				local pityshield = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_EXEPARTICLE2)
				pityshield.blendmode = AST_ADD
				pityshield.tics = P_RandomRange(12,24)
				pityshield.target = player.mo
				pityshield.angle = P_RandomRange(0, 360)*ANG1
				pityshield.movedir = P_RandomRange(0, 360)*ANG1
				player.shieldscale = 0
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					pityshield.flags2 = $|MF2_DONTDRAW
				end
		elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PINK
			and not player.powers[pw_shield]
			and not (player.mo.state == S_PLAY_SPINDASH)
			and not (player.exiting)
				local pinkshield = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_EXEPARTICLE2)
				pinkshield.blendmode = AST_ADD
				pinkshield.tics = P_RandomRange(12,24)
				pinkshield.target = player.mo
				pinkshield.angle = P_RandomRange(0, 360)*ANG1
				pinkshield.movedir = P_RandomRange(0, 360)*ANG1
				player.shieldscale = 0
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					pinkshield.flags2 = $|MF2_DONTDRAW
				end
		elseif ((player.powers[pw_shield] == SH_FORCE|1) or (player.powers[pw_shield] == SH_FORCE))
			and not player.powers[pw_shield]
			and not (player.mo.state == S_PLAY_SPINDASH)
			and not (player.exiting)
				local forceshields = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_EXEPARTICLE2)
				forceshields.blendmode = AST_ADD
				forceshields.tics = P_RandomRange(12,24)
				forceshields.color = SKINCOLOR_PASTEL
				forceshields.colorized = true
				forceshields.target = player.mo
				forceshields.angle = P_RandomRange(0, 360)*ANG1
				forceshields.movedir = P_RandomRange(0, 360)*ANG1
				player.shieldscale = 0
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					forceshields.flags2 = $|MF2_DONTDRAW
				end
		elseif ((player.powers[pw_shield] == SH_THUNDERCOIN) or (player.powers[pw_shield] == SH_ATTRACT))
			and not player.powers[pw_shield]
			and not (player.mo.state == S_PLAY_SPINDASH)
			and not (player.exiting)
				local electricshield = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_EXEPARTICLE2)
				electricshield.blendmode = AST_ADD
				electricshield.tics = P_RandomRange(12,24)
				electricshield.color = SKINCOLOR_GREY
				electricshield.colorized = true
				electricshield.target = player.mo
				electricshield.angle = P_RandomRange(0, 360)*ANG1
				electricshield.movedir = P_RandomRange(0, 360)*ANG1
				player.shieldscale = 0
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					electricshield.flags2 = $|MF2_DONTDRAW
				end
		elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_BUBBLEWRAP
			and not player.powers[pw_shield]
			and not (player.mo.state == S_PLAY_SPINDASH)
			and not (player.exiting)
				local waterballshield = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_EXEPARTICLE2)
				waterballshield.blendmode = AST_ADD
				waterballshield.tics = P_RandomRange(12,24)
				waterballshield.color = SKINCOLOR_SAPPHIRE
				waterballshield.colorized = true
				waterballshield.target = player.mo
				waterballshield.angle = P_RandomRange(0, 360)*ANG1
				waterballshield.movedir = P_RandomRange(0, 360)*ANG1
				player.shieldscale = 0
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					waterballshield.flags2 = $|MF2_DONTDRAW
				end
		elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_WHIRLWIND
			and not player.powers[pw_shield]
			and not (player.mo.state == S_PLAY_SPINDASH)
			and not (player.exiting)
				local whirlshield = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_EXEPARTICLE2)
				whirlshield.blendmode = AST_ADD
				whirlshield.tics = P_RandomRange(12,24)
				whirlshield.color = SKINCOLOR_WHITE
				whirlshield.colorized = true
				whirlshield.target = player.mo
				whirlshield.angle = P_RandomRange(0, 360)*ANG1
				whirlshield.movedir = P_RandomRange(0, 360)*ANG1
				player.shieldscale = 0
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					whirlshield.flags2 = $|MF2_DONTDRAW
				end
			end
			//Fix in a Player Setup
			if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_NONE
				player.shieldscale = skins[player.mo.skin].shieldscale
			end
			//Shield Model
			if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PITY
			and not player.powers[pw_super]
			and not (player.exiting)
				local pityshield = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_EXEPARTICLE2)
				pityshield.blendmode = AST_ADD
				pityshield.tics = P_RandomRange(12,24)
				pityshield.target = player.mo
				pityshield.angle = P_RandomRange(0, 360)*ANG1
				pityshield.movedir = P_RandomRange(0, 360)*ANG1
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					pityshield.flags2 = $|MF2_DONTDRAW
				end
		elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_PINK
			and not player.powers[pw_super]
			and not (player.exiting)
				local pinkshield = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_EXEPARTICLE2)
				pinkshield.blendmode = AST_ADD
				pinkshield.tics = P_RandomRange(12,24)
				pinkshield.target = player.mo
				pinkshield.angle = P_RandomRange(0, 360)*ANG1
				pinkshield.movedir = P_RandomRange(0, 360)*ANG1
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					pinkshield.flags2 = $|MF2_DONTDRAW
				end
		elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ELEMENTAL
			and not player.powers[pw_super]
			and not (player.exiting)
				local elemental = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_EXEPARTICLE2)
				elemental.blendmode = AST_ADD
				elemental.tics = P_RandomRange(12,24)
				elemental.color = SKINCOLOR_MINT
				elemental.colorized = true
				elemental.target = player.mo
				elemental.angle = P_RandomRange(0, 360)*ANG1
				elemental.movedir = P_RandomRange(0, 360)*ANG1
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					elemental.flags2 = $|MF2_DONTDRAW
				end
		elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FLAMEAURA
			and not player.powers[pw_super]
			and not (player.exiting)
				local flame = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_EXEPARTICLE2)
				flame.blendmode = AST_ADD
				flame.tics = P_RandomRange(12,24)
				flame.color = SKINCOLOR_KETCHUP
				flame.colorized = true
				flame.target = player.mo
				flame.angle = P_RandomRange(0, 360)*ANG1
				flame.movedir = P_RandomRange(0, 360)*ANG1
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					flame.flags2 = $|MF2_DONTDRAW
				end
		elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ARMAGEDDON
			and not player.powers[pw_super]
			and not (player.exiting)
				local armaggedon = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_EXEPARTICLE2)
				armaggedon.blendmode = AST_ADD
				armaggedon.tics = P_RandomRange(12,24)
				armaggedon.color = SKINCOLOR_SALMON
				armaggedon.colorized = true
				armaggedon.target = player.mo
				armaggedon.angle = P_RandomRange(0, 360)*ANG1
				armaggedon.movedir = P_RandomRange(0, 360)*ANG1
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					armaggedon.flags2 = $|MF2_DONTDRAW
				end
		elseif ((player.powers[pw_shield] == SH_FORCE|1) or (player.powers[pw_shield] == SH_FORCE))
			and not player.powers[pw_super]
			and not (player.exiting)
				local forceshields = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_EXEPARTICLE2)
				forceshields.blendmode = AST_ADD
				forceshields.tics = P_RandomRange(12,24)
				forceshields.color = SKINCOLOR_PASTEL
				forceshields.colorized = true
				forceshields.target = player.mo
				forceshields.angle = P_RandomRange(0, 360)*ANG1
				forceshields.movedir = P_RandomRange(0, 360)*ANG1
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					forceshields.flags2 = $|MF2_DONTDRAW
				end
		elseif ((player.powers[pw_shield] == SH_THUNDERCOIN) or (player.powers[pw_shield] == SH_ATTRACT))
			and not player.powers[pw_super]
			and not (player.exiting)
				local electricshield = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_EXEPARTICLE2)
				electricshield.blendmode = AST_ADD
				electricshield.tics = P_RandomRange(12,24)
				electricshield.color = SKINCOLOR_GREY
				electricshield.colorized = true
				electricshield.target = player.mo
				electricshield.angle = P_RandomRange(0, 360)*ANG1
				electricshield.movedir = P_RandomRange(0, 360)*ANG1
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					electricshield.flags2 = $|MF2_DONTDRAW
				end
		elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_BUBBLEWRAP
			and not player.powers[pw_super]
			and not (player.exiting)
				local waterballshield = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_EXEPARTICLE2)
				waterballshield.blendmode = AST_ADD
				waterballshield.tics = P_RandomRange(12,24)
				waterballshield.color = SKINCOLOR_SAPPHIRE
				waterballshield.colorized = true
				waterballshield.target = player.mo
				waterballshield.angle = P_RandomRange(0, 360)*ANG1
				waterballshield.movedir = P_RandomRange(0, 360)*ANG1
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					waterballshield.flags2 = $|MF2_DONTDRAW
				end
		elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_WHIRLWIND
			and not player.powers[pw_super]
			and not (player.exiting)
				local whirlshield = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_EXEPARTICLE2)
				whirlshield.blendmode = AST_ADD
				whirlshield.tics = P_RandomRange(12,24)
				whirlshield.color = SKINCOLOR_WHITE
				whirlshield.colorized = true
				whirlshield.target = player.mo
				whirlshield.angle = P_RandomRange(0, 360)*ANG1
				whirlshield.movedir = P_RandomRange(0, 360)*ANG1
				if ((player == displayplayer) and not cv_chasecam.value) or ((player == secondarydisplayplayer) and not cv_chasecam2.value)
					whirlshield.flags2 = $|MF2_DONTDRAW
				end
			end
			//Momentum
			//Mod Momentum
			//Mod Sonic.exe V4.1.5(V5 - Retainer) by Sz
			if player.mo and player.mo.scale and player.mo.friction and player.mo.movefactor then
			local pmo = player.mo
			//Create history
			if player.waterlast == nil then
				player.waterlast = false
				player.dashlast = false
				player.realfriction = pmo.friction
			end
			local skin = skins[pmo.skin]
			
			local water = 1+(pmo.eflags&MFE_UNDERWATER)/MFE_UNDERWATER
			local grounded = P_IsObjectOnGround(pmo)
			local nmom = skin.normalspeed

			if player.dashmode >= 3*TICRATE then
				nmom = player.normalspeed
			end
			
			local scale = pmo.scale
			local friction = FixedDiv(pmo.friction,pmo.movefactor)
			local pmom = FixedDiv(FixedHypot(player.rmomx,player.rmomy),scale)
			local pwup = (player.powers[pw_sneakers]) or (player.powers[pw_super])
			local momangle = R_PointToAngle2(0,0,player.rmomx,player.rmomy)
			if pwup then
				pmom = $*3/5
			end
			local mom = FixedHypot(pmo.momx,pmo.momy)		

			if pmo.eflags&MFE_JUSTHITFLOOR then
				player.normalspeed = skin.normalspeed
				pmo.friction = $-$/10

			elseif grounded then
				local sustain = FixedDiv(min(pmom*water,nmom*2),friction)
					player.normalspeed = max(nmom,sustain)
					
			elseif not(player.dashmode) then
				player.normalspeed = skin.normalspeed
			end
			
			player.waterlast = (pmo.eflags&MFE_UNDERWATER > 0)
			player.dashlast = (player.pflags&PF_STARTDASH > 0)
		end
		if not (player.cmd.buttons & BT_CUSTOM1)
			player.mo.custom1down = 0
		end
		if not (player.cmd.buttons & BT_CUSTOM3)
			player.mo.custom3down = 0
		end
		if not (player.cmd.buttons & BT_SPIN)
			player.mo.doublejump = 0
			player.mo.trickadventure = 0
			player.mo.trickadventure2 = 0
		end
		if not (player.cmd.buttons & BT_JUMP)
			player.mo.thokjump = 0
		end
		if not (player.cmd.buttons & BT_CUSTOM2 and player.cmd.buttons & BT_TOSSFLAG)
			player.mo.pose1down = 0
		end
		if not (player.cmd.buttons & BT_ATTACK and player.cmd.buttons & BT_TOSSFLAG)
			player.mo.pose2down = 0
			end
		end
	end
end)

//Thok in a Hyper Form
addHook("AbilitySpecial", function(player)
    if player.mo and player.mo.skin == "exebladeofdeath" 
	and player.pflags & PF_JUMPED 
	and not(player.pflags & PF_THOKKED)
	and not(player.mo.state == S_PLAY_ROLL)
	and (player.powers[pw_super] and player.hyperform)
		S_StartSound(player.mo, sfx_s3kb6) 
        P_Earthquake(player.mo, player.mo, 256*FRACUNIT)
    	P_StartQuake(79*FRACUNIT, 3)
    	P_RadiusAttack(player.mo, player.mo, 1214*FRACUNIT)
		P_FlashPal(player, PAL_WHITE, 3)
		if (player.mo.eflags & MFE_UNDERWATER)
			P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT)
		else
			P_InstaThrust(player.mo, player.mo.angle, 120*FRACUNIT)
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.skin == "exebladeofdeath"
	and player.playerstate == PST_LIVE
		if player.hyperform
		and not player.powers[pw_super]
		and not player.powers[pw_extralife]
		and not (player.exiting)
		//Hyper Mode Activated
			player.hyperform = false
		end
		if player.rings >= 150
		and ((player.mo.state == S_PLAY_SUPER_TRANS1) or (player.mo.state == S_PLAY_SUPER_TRANS2))
		and not player.hyperform
		and player.powers[pw_super]
			player.hyperform = true
			player.normalspeed = skins[player.mo.skin].normalspeed
			print("Sonic.exe:This is True Power. Goodbye Eggman.")
			S_StartSound(player.mo, sfx_exetrs)
			S_StartSound(player.mo, sfx_exeitp)
			P_Earthquake(player.mo, player.mo, 256*FRACUNIT)
			P_StartQuake(79*FRACUNIT, 3)
			P_FlashPal(player, PAL_WHITE, 3)
			P_NukeEnemies(player.mo, player.mo, RING_DIST)
			SpawnStopSrpingSpinEffect(player)
		end
		if player.powers[pw_super] and not player.hyperform then
			S_ChangeMusic("exesup",true,player)
	elseif player.powers[pw_invulnerability] and not player.powers[pw_super] and not player.hyperform then
			S_ChangeMusic("einv",true,player)
	elseif player.powers[pw_sneakers] and not player.powers[pw_super] and not player.hyperform then
			S_ChangeMusic("exehss",true,player)
	elseif player.powers[pw_super] and player.hyperform == true then
		if (leveltime % 10)
				if (leveltime % 10) == 1
				or (leveltime % 10) == 8
					player.mo.color = SKINCOLOR_SUPER_HYPER_2
				elseif (leveltime % 10) == 2
				or (leveltime % 10) == 7
					player.mo.color = SKINCOLOR_SUPER_HYPER_3
				elseif (leveltime % 10) == 3
				or (leveltime % 10) == 6
					player.mo.color = SKINCOLOR_SUPER_HYPER_4
				elseif (leveltime % 10) == 4
				or (leveltime % 10) == 5
					player.mo.color = SKINCOLOR_SUPER_HYPER_5
				or (leveltime % 10) == 7
					player.mo.color = SKINCOLOR_SUPER_HYPER_6
				elseif (leveltime % 10) == 9
					player.mo.color = SKINCOLOR_SUPER_HYPER_1
				end
			else
				player.mo.color = SKINCOLOR_SUPER_HYPER_1
			end
			S_ChangeMusic("lchse", true, player)
		else
			P_RestoreMusic(player)
		end
	end
end)
addHook("JumpSpinSpecial", function(player)
	if player.mo and player.mo.skin == "exebladeofdeath"
	and player.playerstate == PST_LIVE
	and (player.pflags & PF_JUMPED)
	and (player.mo.state == S_PLAY_JUMP)
	and not (player.mo.state == S_PLAY_FLOAT or player.mo.state == S_PLAY_FLOAT_RUN)
	and (player.charability == CA_SLOWFALL or player.charability == CA_FLOAT)
	and not player.powers[pw_carry]
		player.pflags = $1 & ~PF_THOKKED
		S_StartSound(player.mo, sfx_kc5b)
		S_StartSound(player.mo, sfx_kc4d)
		S_StartSound(player.mo, sfx_susfx7)
		S_StartSound(player.mo, sfx_s3k45)
		player.mo.state = S_PLAY_SPRING_POWER
		player.rebound = false
		P_StartQuake(79*FRACUNIT, 3)
		player.mo.spritexscale = FRACUNIT
		player.mo.spriteyscale = FRACUNIT
		if (player.mo.eflags & MFE_UNDERWATER)
			P_SpawnMobj(player.mo.x - 25*FRACUNIT, player.mo.y, player.mo.z, MT_MEDIUMBUBBLE)
			P_SpawnMobj(player.mo.x + 25*FRACUNIT, player.mo.y, player.mo.z, MT_MEDIUMBUBBLE)
			P_SpawnMobj(player.mo.x, player.mo.y - 25*FRACUNIT, player.mo.z, MT_MEDIUMBUBBLE)
			P_SpawnMobj(player.mo.x, player.mo.y + 25*FRACUNIT, player.mo.z, MT_MEDIUMBUBBLE)
			P_SpawnMobj(player.mo.x - 20*FRACUNIT, player.mo.y - 20*FRACUNIT, player.mo.z, MT_MEDIUMBUBBLE)
			P_SpawnMobj(player.mo.x + 20*FRACUNIT, player.mo.y - 20*FRACUNIT, player.mo.z, MT_MEDIUMBUBBLE)
			P_SpawnMobj(player.mo.x - 20*FRACUNIT, player.mo.y + 20*FRACUNIT, player.mo.z, MT_MEDIUMBUBBLE)
			P_SpawnMobj(player.mo.x + 20*FRACUNIT, player.mo.y + 20*FRACUNIT, player.mo.z, MT_MEDIUMBUBBLE)
			P_SetObjectMomZ(player.mo, 8*FRACUNIT)
		else
			P_SpawnMobj(player.mo.x - 25*FRACUNIT, player.mo.y, player.mo.z, MT_SPINDUST)
			P_SpawnMobj(player.mo.x + 25*FRACUNIT, player.mo.y, player.mo.z, MT_SPINDUST)
			P_SpawnMobj(player.mo.x, player.mo.y - 25*FRACUNIT, player.mo.z, MT_SPINDUST)
			P_SpawnMobj(player.mo.x, player.mo.y + 25*FRACUNIT, player.mo.z, MT_SPINDUST)
			P_SpawnMobj(player.mo.x - 20*FRACUNIT, player.mo.y - 20*FRACUNIT, player.mo.z, MT_SPINDUST)
			P_SpawnMobj(player.mo.x + 20*FRACUNIT, player.mo.y - 20*FRACUNIT, player.mo.z, MT_SPINDUST)
			P_SpawnMobj(player.mo.x - 20*FRACUNIT, player.mo.y + 20*FRACUNIT, player.mo.z, MT_SPINDUST)
			P_SpawnMobj(player.mo.x + 20*FRACUNIT, player.mo.y + 20*FRACUNIT, player.mo.z, MT_SPINDUST)
			P_SetObjectMomZ(player.mo, 15*FRACUNIT)
		end
		for d = 0,7
			local electricdoublejump = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THOK)
			electricdoublejump.sttspeed = 2
			electricdoublejump.tics = 8
			electricdoublejump.sprite = SPR_SHCK
			electricdoublejump.frame = FF_ANIMATE
			electricdoublejump.color = player.mo.color
			electricdoublejump.colorized = true
			electricdoublejump.scale = player.mo.scale
			electricdoublejump.blendmode = AST_ADD
			P_InstaThrust(electricdoublejump, player.mo.angle+(ANGLE_45*d), 35*FRACUNIT)
			local electricdoublejump2 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_EXEPARTICLE)
			electricdoublejump2.sttspeed = 2
			electricdoublejump2.tics = 8
			electricdoublejump2.scale = player.mo.scale
			electricdoublejump2.blendmode = AST_ADD
			local electricdoublejump3 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THOK)
			electricdoublejump3.sttspeed = 2
			electricdoublejump3.tics = 8
			electricdoublejump3.sprite = SPR_BIG_
			electricdoublejump3.frame = FF_ANIMATE
			electricdoublejump3.color = player.mo.color
			electricdoublejump3.colorized = true
			electricdoublejump3.scale = player.mo.scale
			electricdoublejump3.blendmode = AST_ADD
			P_InstaThrust(electricdoublejump3, player.mo.angle+(ANGLE_45*d), 35*FRACUNIT)
		end
	end
end)

//FireShield. Not damage Fire.
addHook("ShouldDamage", function(target, inflictor, damage)
	if (target.skin == "exebladeofdeath")if (inflictor and inflictor.flags & MF_FIRE) 
	and target.player.powers[pw_shield]
		return false
	end
end
end, MT_PLAYER) 

// fire not hurting you
addHook("MobjDamage",function(ptarget, inf, src, damage, damageType)
	for player in players.iterate
		if not (player.mo.firer)
		and player.powers[pw_shield]
			player.mo.firer = 0
		end
		if not (ptarget and ptarget.valid and ptarget.player and ptarget.player.powers[pw_shield]) return end
			if ptarget.skin == "exebladeofdeath" and damageType == DMG_FIRE
			return true
		end
	end
end, MT_PLAYER)

addHook("ThinkFrame", do
	for player in players.iterate
		if player.mo and player.mo.skin == "exebladeofdeath"
		and player.playerstate == PST_LIVE
			if player.custom2down == nil
				player.custom2down = false
			end
			if not (player.mo.nocontrol_focus)
				player.mo.nocontrol_focus = 0
			end
			if player.mo.nocontrol_focus > 0
				player.mo.nocontrol_focus = $1 - 1
			end
			if player.mo.nocontrol_focus > 1
				player.mo.momx = 0
				player.mo.momy = 0
				player.mo.momz = 0
				player.powers[pw_nocontrol] = 2
				player.mo.state = S_PLAY_JUMP
			end
			if player.mo.nocontrol_focus == 1
				player.mo.state = S_PLAY_FALL
				local chsa = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_EXEPARTICLE3)
				A_SetScale(chsa, 24*FRACUNIT, 1)
				chsa.scalespeed = FRACUNIT/2
				chsa.tics = TICRATE
			end
			if (player.cmd.buttons & BT_CUSTOM2)
			and (player.mo.state == S_PLAY_JUMP or player.mo.state == S_PLAY_ROLL)
			and (player.pflags & PF_JUMPED)
			and player.playerstate == PST_LIVE
			and not P_PlayerInPain(player)
			and not player.exiting
			and not player.weapondelay
			and player.custom2down == false
			and not player.powers[pw_carry]
				for i = 1, 30
					local skullburst = P_SPMAngle(player.mo, MT_SKULSHOT, FixedAngle(12*FRACUNIT)*i, 0, MF2_RAILRING)
					if skullburst
					and skullburst.valid
						skullburst.color = SKINCOLOR_SALMON
						skullburst.colorized = true
						skullburst.fuse = 3
						local skullburstfire = P_SpawnGhostMobj(player.mo)
						skullburstfire.color = SKINCOLOR_RED
						skullburstfire.colorized = true
						skullburstfire.blendmode = AST_ADD
					end
				end
				if player.powers[pw_super]
					S_StartSound(player.mo, sfx_s3ka0)
					player.weapondelay = 25
					player.mo.nocontrol_focus = 18
				elseif not player.powers[pw_super] and player.hyperform == true
					player.weapondelay = 15
					player.mo.nocontrol_focus = 5
				else
					S_StartSound(player.mo, sfx_s3ka0)
					S_StartSound(player.mo, sfx_lsde)
					S_StartSound(player.mo, sfx_s3ka0)
					player.weapondelay = 5*TICRATE
					player.mo.nocontrol_focus = 28
				end
			end
			if (player.cmd.buttons & BT_CUSTOM2)
				player.custom2down = true
			else
				player.custom2down = false
			end
		end
	end
end)

addHook("MobjCollide", function(spikes, exe2)
    if spikes
    and spikes.health
    and spikes.valid
    and (spikes.type == MT_SPIKE)
    and exe2.skin == "exebladeofdeath"
        if exe2
        and exe2.player
        and exe2.valid
        and exe2.type == MT_PLAYER
        and not (exe2.player.runspeed == nil)
            if not (exe2.z > spikes.z+spikes.height)
            and not (spikes.z > exe2.z+spikes.height)
                if exe2.player.speed >= exe2.player.runspeed
                and exe2.player.runspeed > 0
					P_KillMobj(spikes, exe2, exe2)
					exe2.player.runspeed = $1 + 10
                end
            end
        end
    end
end, MT_SPIKE)

addHook("MobjCollide", function(spikes2, exe)
    if spikes2
    and spikes2.health
    and spikes2.valid
    and (spikes2.type == MT_WALLSPIKE)
    and exe.skin == "exebladeofdeath"
        if exe
        and exe.player
        and exe.valid
        and exe.type == MT_PLAYER
        and not (exe.player.runspeed == nil)
            if not (exe.z > spikes2.z+spikes2.height)
            and not (spikes2.z > exe.z+spikes2.height)
                if exe.player.speed >= exe.player.runspeed
                and exe.player.runspeed > 0
					P_KillMobj(spikes2, exe, exe)
					exe.player.runspeed = $1 + 10
                end
            end
        end
    end
end, MT_WALLSPIKE)

addHook("MobjCollide", function(spikes3, exe3)
    if spikes3
    and spikes3.health
    and spikes3.valid
    and (spikes3.type == MT_SALOONDOOR)
    and exe3.skin == "exebladeofdeath"
        if exe3
        and exe3.player
        and exe3.valid
        and exe3.type == MT_PLAYER
        and not (exe3.player.runspeed == nil)
            if not (exe3.z > spikes3.z+spikes3.height)
            and not (spikes3.z > exe3.z+spikes3.height)
                if exe3.player.speed >= exe3.player.runspeed
                and exe3.player.runspeed > 0
					P_KillMobj(spikes3, exe3, exe3)
					exe3.player.runspeed = $1 + 10
					S_StartSound(exe3, sfx_wbreak)
					for i = 0,7,1
						local r = exe3.radius/FRACUNIT
						local xy = (P_RandomRange(r, -r)*FRACUNIT)
						local z = (P_RandomKey(exe3.height/FRACUNIT)*FRACUNIT)
						local wood = P_SpawnMobj(exe3.x + xy, exe3.y + xy, exe3.z + z, MT_WOODDEBRIS)
						wood.momx = exe3.momx/3
						wood.momy = exe3.momy/3
						wood.scale = exe3.scale
					end
                end
            end
        end
    end
end, MT_SALOONDOOR)

addHook("MobjCollide", function(spikes4, exe4)
    if spikes4
    and spikes4.health
    and spikes4.valid
    and (spikes4.type == MT_SALOONDOORCENTER)
    and exe4.skin == "exebladeofdeath"
        if exe4
        and exe4.player
        and exe4.valid
        and exe4.type == MT_PLAYER
        and not (exe4.player.runspeed == nil)
            if not (exe4.z > spikes4.z+spikes4.height)
            and not (spikes4.z > exe4.z+spikes4.height)
                if exe4.player.speed >= exe4.player.runspeed
                and exe4.player.runspeed > 0
					P_KillMobj(spikes4, exe4, exe4)
					exe4.player.runspeed = $1 + 10
					S_StartSound(exe4, sfx_wbreak)
					for i = 0,7,1
						local r = exe4.radius/FRACUNIT
						local xy = (P_RandomRange(r, -r)*FRACUNIT)
						local z = (P_RandomKey(exe4.height/FRACUNIT)*FRACUNIT)
						local wood = P_SpawnMobj(exe4.x + xy, exe4.y + xy, exe4.z + z, MT_WOODDEBRIS)
						wood.momx = exe4.momx/3
						wood.momy = exe4.momy/3
						wood.scale = exe4.scale
					end
                end
            end
        end
    end
end, MT_SALOONDOORCENTER)

//speed Hud
hud.add(function(v, player)
	if not (player.speed > 60*FRACUNIT) return end
	if player.mo and player.mo.valid and player.mo.skin == "exebladeofdeath"
		if leveltime%3 == 1 then
			v.draw(0, 0, v.cachePatch("speed1"), V_SNAPTOTOP|V_PERPLAYER|V_60TRANS)
		end
	end
end, "game")

//Hud Nicknames
hud.add(function(v, player, cam)
	if (player.mo and player.mo.valid and player.mo.skin == "exebladeofdeath")
	and not player.powers[pw_carry]
		v.draw(35, 169, v.cachePatch("SONICEXENICK"), V_HUDTRANS|V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
	end
end, "game")

freeslot("MT_DEATHBADNIKS", "sfx_deadba", "sfx_badnk", "MT_BLOODFROMFLICKY", "S_BLOODFROMFLICKY", "SPR_BLOD", "SPR_EMK_")

mobjinfo[MT_BLOODFROMFLICKY] = {
	speed = 40*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 24*FRACUNIT,
	spawnstate = S_BLOODFROMFLICKY,
	flags = MF_SCENERY
}

states[S_BLOODFROMFLICKY] = {
	sprite = SPR_BLOD,
	frame = A,
	tics = 15,
	nextstate = S_NULL
}

sfxinfo[sfx_deadba].caption = "Sonic.EXE Damage Badniks"

sfxinfo[sfx_badnk].caption = "Blood Flicky"

addHook("MobjThinker", function(mo)
	if mo
	and mo.valid
	and mo.type == MT_BLOODFROMFLICKY
	and mo.state == mobjinfo[mo.type].spawnstate
		local bloodfucked = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		bloodfucked.sprite = SPR_EMK_
		bloodfucked.frame = B|TR_TRANS60
		bloodfucked.blendmode = AST_ADD
		local bloodfucked2 = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		bloodfucked2.sprite = SPR_EMK_
		bloodfucked2.frame = A|TR_TRANS60
		bloodfucked2.blendmode = AST_ADD
	end
end, MT_BLOODFROMFLICKY)

//monitor detal's
freeslot("sfx_damonr", "MT_EXEMONITORPARTICLE", "S_EXEMONITORPARTICLE", "SPR_DETL")

mobjinfo[MT_EXEMONITORPARTICLE] = {
	speed = 40*FRACUNIT,
	radius = 16*FRACUNIT,
	height = 24*FRACUNIT,
	spawnstate = S_EXEMONITORPARTICLE,
	flags = MF_SCENERY
}

states[S_EXEMONITORPARTICLE] = {
	sprite = SPR_DETL,
	frame = A,
	tics = 15,
	nextstate = S_NULL
}

addHook("MobjThinker", function(mo)
	if mo
	and mo.valid
	and mo.type == MT_EXEMONITORPARTICLE
	and mo.state == mobjinfo[mo.type].spawnstate
		local monitorfucked = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		monitorfucked.sprite = SPR_EMK_
		monitorfucked.frame = B|TR_TRANS60
		monitorfucked.blendmode = AST_ADD
		monitorfucked.color = SKINCOLOR_WHITE
		monitorfucked.colorized = true
		local monitorfucked2 = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		monitorfucked2.sprite = SPR_EMK_
		monitorfucked2.frame = A|TR_TRANS60
		monitorfucked2.blendmode = AST_ADD
		monitorfucked2.color = SKINCOLOR_WHITE
		monitorfucked2.colorized = true
	end
end, MT_EXEMONITORPARTICLE)

addHook("MobjDeath", function(mo, inf, source)
	if mo
	and mo.valid
	and (mo.flags & MF_ENEMY)
		if source
		and source.valid
		and source.player
		and source.skin == "exebladeofdeath"
			local damagebadniks = P_SpawnGhostMobj(inf)
			damagebadniks.color = SKINCOLOR_SALMON
			damagebadniks.colorized = true
			damagebadniks.blendmode = AST_ADD
			local sh = P_SpawnMobjFromMobj(inf, 0, 0, 0, MT_THOK)
			sh.tics = 50
			sh.fuse = 50
			sh.flags2 = $|MF2_DONTDRAW
			local badnikisdead = P_SpawnMobjFromMobj(inf, 0, 0, inf.height/3, MT_DEATHBADNIKS)
			local height = inf.height/32
			if height < inf.scale
				height = inf.scale
			end

			badnikisdead.sprite = SPR_GPLZ
			badnikisdead.frame = A
			badnikisdead.blendmode = AST_ADD
			badnikisdead.scale = height
			badnikisdead.scalespeed = $*2
			badnikisdead.destscale = $*99
			badnikisdead.target = inf
			badnikisdead.fuse = 25
			badnikisdead.tics = 40
			local prandom = P_RandomRange(5, 15)
				for i = 1, prandom
					local blood = P_SPMAngle(mo, MT_BLOODFROMFLICKY, R_PointToAngle2(inf.x, inf.y, mo.x, mo.y)+P_RandomRange(-30, 30)*ANG1)
					if blood
					and blood.valid
					P_InstaThrust(blood, blood.angle, FixedHypot(inf.momx, inf.momy))
					P_SetObjectMomZ(blood, P_RandomRange(4, 8)*FRACUNIT)
					blood.frame = P_RandomRange(0, 2)
				end
			end
			S_StartSound(source, sfx_deadba)
			S_StartSound(source, sfx_badnk)
		end
	end
end)

//Mod Reusable from L_SAExplosions-v1.pk3 - Part 1
addHook("MobjThinker", function(s)
	if s.valid
		if not s.fuse
			s.fuse = 25
			return
		else
			if ((s.frame & ~FF_FULLBRIGHT & ~FF_TRANSMASK) < P)
				s.frame = ($+1)|FF_FULLBRIGHT
			end
			if (s.fuse < 18)
				s.frame = $|(TR_TRANS90-((s.fuse/2)*FRACUNIT))
			else
				s.frame = $|TR_TRANS30
			end
		end
		if s.valid and s.target and s.target.valid
			S_StopSoundByID(s.target, sfx_pop)
			return
		end
	end
end, MT_DEATHBADNIKS)

addHook("MobjDeath", function(mo, inf, source)
	if mo
	and mo.valid
	and (mo.flags & MF_MONITOR)
		if source
		and source.valid
		and source.player
		and source.skin == "exebladeofdeath"
			local damagemonitors = P_SpawnGhostMobj(inf)
			damagemonitors.color = SKINCOLOR_SALMON
			damagemonitors.colorized = true
			damagemonitors.blendmode = AST_ADD
			local prandom = P_RandomRange(5, 15)
			for i = 1, prandom
				local monitordetals = P_SPMAngle(mo, MT_EXEMONITORPARTICLE, R_PointToAngle2(inf.x, inf.y, mo.x, mo.y)+P_RandomRange(-30, 30)*ANG1)
				if monitordetals
				and monitordetals.valid
					P_InstaThrust(monitordetals, monitordetals.angle, FixedHypot(inf.momx, inf.momy))
					P_SetObjectMomZ(monitordetals, P_RandomRange(4, 8)*FRACUNIT)
					monitordetals.frame = P_RandomRange(0, 2)
				end
			end
		S_StartSound(source, sfx_damonr)
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo
	and player.mo.valid
	and player.mo.skin == "exebladeofdeath"
	and not (player.powers[pw_carry] == CR_NIGHTSMODE)
		if player.playerstate == PST_LIVE
			if player.mo.hp == nil
				player.mo.hp = 100
			end
			if player.mo.hp <= 0
				S_StopSound(player.mo)
				P_KillMobj(player.mo)
			end
			if player.mo.hp > 100
				player.mo.hp = 100
			end
			if player.powers[pw_super]
			and player.mo.hp < 100
				player.mo.hp = $1 + 1
			end
		elseif player.playerstate == PST_DEAD
			if player.mo.hp == nil
				player.mo.hp = 0
			end
			if player.mo.hp > 0
				player.mo.hp = 0
			end
		end
	end
end)

local function BloodSplit(mo, inf)
	local prandom = P_RandomRange(5, 15)
	if inf
		for i = 1, prandom
		local blood = P_SPMAngle(mo, MT_BLOODFROMFLICKY, R_PointToAngle2(inf.x, inf.y, mo.x, mo.y)+P_RandomRange(-30, 30)*ANG1)
			if blood
			and blood.valid
				P_InstaThrust(blood, blood.angle, P_RandomRange(4, 8)*FRACUNIT)
				P_SetObjectMomZ(blood, P_RandomRange(4, 8)*FRACUNIT)
				blood.frame = P_RandomRange(0, 2)
			end
		end
	else
		for i = 1, prandom
			local blood = P_SPMAngle(mo, MT_BLOODFROMFLICKY, P_RandomRange(0, 360)*ANG1)
			if blood
			and blood.valid
				P_InstaThrust(blood, blood.angle, P_RandomRange(4, 8)*FRACUNIT)
				P_SetObjectMomZ(blood, P_RandomRange(4, 8)*FRACUNIT)
				blood.frame = P_RandomRange(0, 2)
			end
		end
	end
end

//Sound From Damage HP
freeslot("sfx_exebet")

addHook("MobjDamage", function(mo, inf, source)
	if mo
	and mo.player
	and mo.skin == "exebladeofdeath"
	and mo.player.playerstate == PST_LIVE
	and not (mo.player.powers[pw_carry] == CR_NIGHTSMODE)
	and not mo.player.powers[pw_shield] //With shield Damage is not work!
		if inf
		and inf.valid
			BloodSplit(mo, inf)
		else
			BloodSplit(mo)
		end
		if mo.player.rings > 0
			mo.hp = $1 - 10
			S_StartSound(mo, sfx_exebet)
		else
			mo.hp = $1 - 25
			P_DoPlayerPain(mo.player, source, inf)
			P_PlayerWeaponPanelOrAmmoBurst(mo.player)
			P_PlayerEmeraldBurst(mo.player)
			P_PlayerFlagBurst(mo.player)
			P_PlayRinglossSound(mo)
			S_StartSound(mo, sfx_exebet)
			if source
			and source.valid
			and source.player
				P_AddPlayerScore(source.player, 50)
				S_StartSound(source, sfx_exebet)
			end
		return true
		end
	end
end, MT_PLAYER)

addHook("TouchSpecial", function(ring, mo)
	if ring
	and ring.valid
	and ring.type == MT_RING
	and ring.health //YOU ARE NOT DEAD!?!?!
		if mo
		and mo.player
		and mo.skin == "exebladeofdeath"
		and mo.player.playerstate == PST_LIVE
		and not (mo.player.powers[pw_carry] == CR_NIGHTSMODE)
		and mo.hp < 100
			mo.hp = $1 + 1
		end
	end
end, MT_RING)

addHook("MobjDeath", function(monitor, inf, mo)
	if monitor
	and monitor.type == MT_RING_BOX
	and monitor.valid
	and monitor.flags & MF_MONITOR
		if mo
		and mo.player
		and mo.player.playerstate == PST_LIVE
		and not (mo.player.powers[pw_carry] == CR_NIGHTSMODE)
		and mo.skin == "exebladeofdeath"
			mo.hp = $1 + 10
		end
	end
end, MT_RING_BOX)

addHook("MobjDeath", function(up, inf, mo)
	if up
	and up.type == MT_1UP_BOX
	and up.valid
	and up.flags & MF_MONITOR
		if mo
		and mo.player
		and mo.player.playerstate == PST_LIVE
		and not (mo.player.powers[pw_carry] == CR_NIGHTSMODE)
		and mo.skin == "exebladeofdeath"
			mo.hp = $1 + 100
		end
	end
end, MT_1UP_BOX)

local function EXE_HP(v, player, cam)
	if player.mo
	and player.mo.valid
	and player.mo.skin == "exebladeofdeath"
	and not (player.powers[pw_carry] == CR_NIGHTSMODE)
		local hp = (player.mo.hp*FRACUNIT)/85196 //1.3
		local bar_color = 35
		if P_PlayerInPain(player)
			if (leveltime % 4) < 2
				bar_color = 32
			else
				bar_color = 35
			end
		else
			if (leveltime % 16)
			local time = (leveltime % 16)
				if time >= 0
				and time <= 4
					bar_color = 35
				elseif time == 5
				or time == 13
					bar_color = 34
				elseif time == 6
				or time == 12
					bar_color = 33
				elseif time >= 7
				and time <= 11
					bar_color = 32
				end
			end
		end
		if hp >= 0
			v.drawFill(47, 69, hp, 11, bar_color+V_SNAPTOTOP|V_SNAPTOLEFT)
			v.drawString(129, 70, player.mo.hp, V_SNAPTOTOP|V_SNAPTOLEFT|V_REDMAP)
			v.draw(4, 54, v.cachePatch("SEXEBA1"), V_SNAPTOTOP|V_SNAPTOLEFT)
		end
	end
end

hud.add(EXE_HP, "game")

//One Bounce
freeslot("sfx_exebnc", "S_BOUNCESTRANGE_DEAD")

addHook("MobjThinker", function(mobj)
	local player = mobj.player
	if (player.mo and player.playerstate == PST_LIVE and player.mo.skin == "exebladeofdeath")
		if player.rebound and player.playerstate == PST_LIVE and player.mo.state == S_PLAY_SPRING then
			S_StartSound(player.mo, sfx_sprong)
			player.mo.spritexscale = FRACUNIT
			player.mo.spriteyscale = FRACUNIT
			if player.powers[pw_justsprung]
			or (player.mo.eflags & MFE_SPRUNG)
				player.mo.momz = $*5/4
				player.mo.momx = $*5/4
				player.mo.momy = $*5/4
				player.charflags = $1|SF_RUNONWATER
			end
		end
		if (player.pflags & PF_JUMPED)
		and (player.cmd.buttons & BT_CUSTOM3)
		and not (player.prevspin)
		and not (player.pflags & PF_THOKKED)
		and player.playerstate == PST_LIVE
		and not player.powers[pw_carry]
		and not (player.mo.state == S_PLAY_SPRING_POWER or player.mo.state == S_PLAY_JUMP_POWER or player.mo.state == S_PLAY_FALL)
			player.rebound = true
			player.mo.state = S_PLAY_JUMP
		end
		if (player.rebound)
		and (P_IsObjectOnGround(player.mo))
		and not (player.pflags & PF_THOKKED)
		and player.playerstate == PST_LIVE
		and not player.powers[pw_carry]
			player.pflags = $1|PF_THOKKED
			player.pflags = $1|PF_JUMPED
			player.rebound = false
			player.mo.state = S_PLAY_JUMP
			S_StartSound(player.mo, sfx_exebnc) //One Bounce Sound  \
			S_StartSound(player.mo, sfx_susfx7) //Electring Reaction } One Bounce Sound.
			P_StartQuake(79*FRACUNIT, 3) 		//Quake     // 		/
			player.charflags = $1|SF_RUNONWATER
			if (player.mo.eflags & MFE_UNDERWATER)
				P_SetObjectMomZ(player.mo, 8*FRACUNIT, false)
			else
				P_SetObjectMomZ(player.mo, 15*FRACUNIT, false)
			end
			for d = 0,7
				local electricdoublejump = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THOK)
				electricdoublejump.sttspeed = 2
				electricdoublejump.tics = 8
				electricdoublejump.sprite = SPR_SHCK
				electricdoublejump.frame = FF_ANIMATE
				electricdoublejump.color = player.mo.color
				electricdoublejump.colorized = true
				electricdoublejump.scale = player.mo.scale
				electricdoublejump.blendmode = AST_ADD
				P_InstaThrust(electricdoublejump, player.mo.angle+(ANGLE_45*d), 35*FRACUNIT)
				local electricdoublejump2 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_EXEPARTICLE)
				electricdoublejump2.sttspeed = 2
				electricdoublejump2.tics = 8
				electricdoublejump2.scale = player.mo.scale
				electricdoublejump2.blendmode = AST_ADD
				local electricdoublejump4 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THOK)
				electricdoublejump4.scale = player.mo.scale
				electricdoublejump4.state = S_BOUNCESTRANGE_DEAD
				electricdoublejump4.flags2 = $1|MF2_SPLAT
				electricdoublejump4.renderflags = $1|RF_NOSPLATBILLBOARD
				local electricdoublejump3 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THOK)
				electricdoublejump3.tics = 8
				electricdoublejump3.sprite = SPR_BIG_
				electricdoublejump3.frame = FF_ANIMATE
				electricdoublejump3.color = player.mo.color
				electricdoublejump3.colorized = true
				electricdoublejump3.scale = player.mo.scale
				electricdoublejump3.blendmode = AST_ADD
				P_InstaThrust(electricdoublejump3, player.mo.angle+(ANGLE_45*d), 35*FRACUNIT)
			end
		end
		if (player.rebound)
		and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
			P_SetObjectMomZ(player.mo, -34*FRACUNIT, false)
			player.pflags = $1|PF_THOKKED
			player.charflags = $1 & ~SF_RUNONWATER
		end
		if (player.rebound)
			if (player.mo.eflags & MFE_GOOWATER)
				player.rebound = false
			end
		end
		if (player.rebound)
			SuperSpeed(player.mo, MT_THOK, 4*FRACUNIT)
			player.mo.spritexscale = FRACUNIT+FixedDiv(player.mo.momz/96,player.mo.scale)
			player.mo.spriteyscale = FRACUNIT-FixedDiv(player.mo.momz/96,player.mo.scale)
			if not (player.pflags & PF_JUMPED)
			and player.playerstate == PST_LIVE
				player.rebound = false
				player.mo.spritexscale = FRACUNIT
				player.mo.spriteyscale = FRACUNIT
			end
		end
		if not (player.pflags & PF_JUMPED)
		and player.playerstate == PST_LIVE
			player.bounce = false
		end
		player.prevspin = player.cmd.buttons & BT_CUSTOM3
	end
end, MT_PLAYER)

//Death pit in a Whirl Shield
addHook("ShouldDamage", function(t, i, s, d, dt)
	if dt == DMG_DEATHPIT and t.player and t.skin == "exebladeofdeath" and (t.player.powers[pw_shield] & SH_NOSTACK == SH_WHIRLWIND)
		P_SetObjectMomZ(t, 32*FRACUNIT)
		t.player.pflags = $&~PF_THOKKED|PF_JUMPED
		t.state = S_PLAY_SPRING_POWER
		P_RemoveShield(t.player)
		S_StartSound(t, sfx_wdjump)
		S_StartSound(t, sfx_kc5b)
		S_StartSound(t, sfx_kc4d)
		S_StartSound(t, sfx_susfx7)
		S_StartSound(t, sfx_s3k45)
		P_SpawnMobj(t.x - 25*FRACUNIT, t.y, t.z, MT_SPINDUST)
		P_SpawnMobj(t.x + 25*FRACUNIT, t.y, t.z, MT_SPINDUST)
		P_SpawnMobj(t.x, t.y - 25*FRACUNIT, t.z, MT_SPINDUST)
		P_SpawnMobj(t.x, t.y + 25*FRACUNIT, t.z, MT_SPINDUST)
		P_SpawnMobj(t.x - 20*FRACUNIT, t.y - 20*FRACUNIT, t.z, MT_SPINDUST)
		P_SpawnMobj(t.x + 20*FRACUNIT, t.y - 20*FRACUNIT, t.z, MT_SPINDUST)
		P_SpawnMobj(t.x - 20*FRACUNIT, t.y + 20*FRACUNIT, t.z, MT_SPINDUST)
		P_SpawnMobj(t.x + 20*FRACUNIT, t.y + 20*FRACUNIT, t.z, MT_SPINDUST)
		return false
	end
end)

freeslot("sfx_exedit", "sfx_exeris", "sfx_exeit", "sfx_exeinp", "sfx_exestp", "sfx_exeins", "sfx_exeprt", "sfx_exeris", "sfx_exeit")

addHook("ShieldSpawn", function(player)
	if (player.mo and player.mo.valid and player.mo.skin == "exebladeofdeath")
	and player.playerstate == PST_LIVE
	and not (player.powers[pw_carry] == CR_NIGHTSMODE)
	and not player.powers[pw_super]
	and not player.exiting
	and not player.powers[pw_invulnerability]
	and not (CBW_Battle)
		if player.powers[pw_shield]
			for d = 0, 16
				P_SpawnParaloop(player.mo.x, player.mo.y, player.mo.z + player.mo.height, FixedMul(128*FRACUNIT, player.mo.scale), 16, MT_NIGHTSPARKLE, d*(ANGLE_22h), S_NIGHTSPARKLESUPER1, true)
			end
			if player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ELEMENTAL
			and not player.powers[pw_super]
				S_StartSound(player.mo, sfx_exeins)
				S_StartSound(player.mo, sfx_kc48)
				local elemntalghost = P_SpawnGhostMobj(player.mo)
				elemntalghost.color = SKINCOLOR_MINT
				elemntalghost.colorized = true
				elemntalghost.blendmode = AST_ADD
				A_OldRingExplode(player.mo, MT_SPINDUST, 0)
		elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_FLAMEAURA
			and not player.powers[pw_super]
				local flamelghost = P_SpawnGhostMobj(player.mo)
				flamelghost.color = SKINCOLOR_KETCHUP
				flamelghost.colorized = true
				flamelghost.blendmode = AST_ADD
				S_StartSound(player.mo, sfx_exeprt)
				S_StartSound(player.mo, sfx_kc48)
				A_OldRingExplode(player.mo, MT_SPINDUST, 0)
		elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_ARMAGEDDON
			and not player.powers[pw_super]
				local salmonghost = P_SpawnGhostMobj(player.mo)
				salmonghost.color = SKINCOLOR_SALMON
				salmonghost.colorized = true
				salmonghost.blendmode = AST_ADD
				S_StartSound(player.mo, sfx_exedit)
				S_StartSound(player.mo, sfx_kc48)
				A_OldRingExplode(player.mo, MT_SONIC3KBOSSEXPLODE, 0)
		elseif ((player.powers[pw_shield] == SH_FORCE|1) or (player.powers[pw_shield] == SH_FORCE))
			and not player.powers[pw_super]
				local pastelghost = P_SpawnGhostMobj(player.mo)
				pastelghost.color = SKINCOLOR_PASTEL
				pastelghost.colorized = true
				pastelghost.blendmode = AST_ADD
				S_StartSound(player.mo, sfx_exeris)
				S_StartSound(player.mo, sfx_kc48)
				A_OldRingExplode(player.mo, MT_PARTICLE, 0)
		elseif ((player.powers[pw_shield] == SH_PITY) or (player.powers[pw_shield] == SH_PINK))
			and not player.powers[pw_super]
				local difficulghost = P_SpawnGhostMobj(player.mo)
				difficulghost.color = player.mo.color
				difficulghost.colorized = true
				difficulghost.blendmode = AST_ADD
				S_StartSound(player.mo, sfx_exeit)
				S_StartSound(player.mo, sfx_kc48)
				A_OldRingExplode(player.mo, MT_PARTICLE, 0)
		elseif ((player.powers[pw_shield] == SH_THUNDERCOIN) or (player.powers[pw_shield] == SH_ATTRACT))
			and not player.powers[pw_super]
				local greyghost = P_SpawnGhostMobj(player.mo)
				greyghost.color = SKINCOLOR_GREY
				greyghost.colorized = true
				greyghost.blendmode = AST_ADD
				S_StartSound(player.mo, sfx_exeinp)
				S_StartSound(player.mo, sfx_kc48)
				A_OldRingExplode(player.mo, MT_WATERZAP, 0)
		elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_BUBBLEWRAP
			and not player.powers[pw_super]
				local cornflwerghost = P_SpawnGhostMobj(player.mo)
				cornflwerghost.color = SKINCOLOR_CORNFLOWER
				cornflwerghost.colorized = true
				cornflwerghost.blendmode = AST_ADD
				S_StartSound(player.mo, sfx_exestp)
				S_StartSound(player.mo, sfx_kc48)
				A_OldRingExplode(player.mo, MT_SPINDUST, 0)
		elseif player.powers[pw_shield] & ~SH_FIREFLOWER == SH_WHIRLWIND
			and not player.powers[pw_super]
				local whirlghost = P_SpawnGhostMobj(player.mo)
				whirlghost.color = SKINCOLOR_WHITE
				whirlghost.colorized = true
				whirlghost.blendmode = AST_ADD
				S_StartSound(player.mo, sfx_exeold)
				S_StartSound(player.mo, sfx_kc48)
				A_OldRingExplode(player.mo, MT_SPINDUST, 0)
			end
		end
	end
end)

addHook("MobjMoveBlocked", function(mo)
	if (mo and mo.player and mo.valid and mo.skin == "exebladeofdeath")
	and mo.player.playerstate == PST_LIVE
	and not mo.player.exiting
	and not mo.player.powers[pw_super]
	and ((mo.player.powers[pw_shield] == SH_FORCE|1) or (mo.player.powers[pw_shield] == SH_FORCE))
	and not (CBW_Battle)
	and not ((gametype == GT_TEAMMATCH) or (gametype == GT_CTF) or (gametype == GT_MATCH) or (gametype == GT_TAG) or (gametype ==  GT_HIDEANDSEEK) or (gametype == GT_EXEAMOGUS) or (gametype == GT_EXESURVIVAL))
		P_BounceMove(mo)
		P_InstaThrust(mo, R_PointToAngle2(0, 0, mo.momx, mo.momy), 24*FRACUNIT)
		local wallbounce = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
		wallbounce.state = S_SSPK1
		S_StartSound(mo, sfx_s3k49)
		local wallbounceghost = P_SpawnGhostMobj(mo)
		wallbounceghost.color = SKINCOLOR_PASTEL
		wallbounceghost.fuse = 6
		wallbounceghost.colorized = true
		wallbounceghost.blendmode = AST_ADD
		mo.state = S_PLAY_EXETIOR_EXE_DROPDASH2
		mo.player.pflags = $1|PF_THOKKED
		mo.player.pflags = $1|PF_JUMPED
		mo.rebound = false
		if (mo.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER))
			P_SetObjectMomZ(mo, 6*FRACUNIT)
		else
			P_SetObjectMomZ(mo, 12*FRACUNIT)
		end
	end
end, MT_PLAYER)

local function ShieldWhirlSlowFalling(player)
	if not (player.mo and player.mo.valid) and (player.mo.skin == "exebladeofdeath") then return end 
	if player.powers[pw_shield] == SH_WHIRLWIND
	and (player.mo.skin == "exebladeofdeath")
		if player.pflags & PF_SHIELDABILITY
		and (player.mo.skin == "exebladeofdeath")
			if (P_MobjFlip(player.mo)*player.mo.momz < -gravity*10)
			and (player.mo.skin == "exebladeofdeath")
				player.mo.momz = P_MobjFlip(player.mo)*-gravity*10
			end
		end
	end
end

addHook("PlayerThink", ShieldWhirlSlowFalling)